/*!
 * @file: 多玩全站通用页脚
 * @author: David(liudawei@yy.com)
 * @update: 2015-06-17 14:47:19
 */

(function() {
    var typeClass = '';
    var siteDomain = document.domain;
    var scripts = document.getElementsByTagName('script');
    var src = scripts[scripts.length - 1].src;
    var thisYear = new Date().getFullYear();

    // 解析参数并存储到 config 变量中
    var arg = src.indexOf('?') !== -1 ? src.split('?').pop() : '';
    var config = {};
    arg.replace(/(\w+)(?:=([^&]*))?/g, function(a, key, value) {
        config[key] = value;
    });
    
    if (config['type'] === 'white') {
        typeClass = ' dwCommonFooter--white';
    }
    
    var duowanCommonFooter = {
        
        // 全站公共页脚导航
        navigation: function(){
            var navStyle = [
                '<style>',
                    '.dwCommonFooter {clear:both;width:100%;margin:0 auto;padding:25px 0;background: #222;color: #666;}',
                    '.dwCommonFooter img{width:auto}',
                    '.dwCommonFooter__split {opacity: .6;}',
                    '.dwCommonFooter__row {margin:0 auto 8px;text-align:center;line-height:1;}',
                    '.dwCommonFooter__row p {margin-bottom:8px;}',
                    '.dwCommonFooter a {margin:0 5px;color: #666;}',
                    '.dwCommonFooter a:hover {color: #8e8e8e;}',
                    '.dwCommonFooter__highlight {color:#F40;}',
                    '.dwCommonFooter__row--approve {padding-top: 5px;margin-bottom: 38px;}',
                    '.dwCommonFooter__row--approve i, .dwCommonFooter__row--logo a {display:inline-block;*zoom:1;*display:inline;background-image: url("http://assets.dwstatic.com/common/img/footer-sprite.png?20151231");background-repeat:no-repeat;}',
                    '.dwCommonFooter__row--approve i {vertical-align: -4px;margin-right: 5px;margin-left: 12px;}',
                    '.dwCommonFooter__row--approve .approveIcon1 {width: 20px; height: 20px; background-position: -0px -92px;}',
                    '.dwCommonFooter__row--approve .approveIcon2 {width: 16px; height: 20px; background-position: -24px -92px;}',
                    '.dwCommonFooter__row--approve .approveIcon3 {width: 20px; height: 20px; background-position: -44px -92px;}',
                    '.dwCommonFooter__row--approve .approveIcon4 {width: 18px; height: 18px; background-position: -92px -92px;}',
                    '.dwCommonFooter__row--approve .approveIcon5 {width: 20px; height: 20px; background-position: -68px -92px;}',
                    '.dwCommonFooter__row--approve .approveIcon6 {width: 20px; height: 17px; background-position: -114px -92px;}',
                    '.dwCommonFooter__row--logo a {margin: 0 20px;font-size: 0;line-height:0;vertical-align: top;overflow: hidden;}',
                    '.dwCommonFooter__logoSplit {height: 34px;width: 1px; margin-top: 8px;line-height: 34px;overflow: hidden;display:inline-block;*zoom:1;*display:inline;vertical-align: top;background-color: #3d3d3d;}',
                    '.dwCommonFooter__huanju {width: 115px; height: 42px; margin-top: 2px; background-position: -0px -0px;}',
                    '.dwCommonFooter__huyu {width: 166px; height: 41px; background-position: -119px -0px;}',
                    '.dwCommonFooter__row--logo .dwCommonFooter__huanju {margin-top: 2px;}',
                    '.dwCommonFooter--white {background: #fff;color: #999;}',
                    '.dwCommonFooter--white a {color: #999;}',
                    '.dwCommonFooter--white a:hover {color: #666;}',
                    '.dwCommonFooter--white .dwCommonFooter__logoSplit {background-color: #ccc;}',
                    '.dwCommonFooter--white .dwCommonFooter__huanju {background-position: -0px -46px;}',
                    '.dwCommonFooter--white .dwCommonFooter__huyu {background-position: -119px -45px;}',
                '</style>'
            ];
            navStyle = navStyle.join('');
            
            var navHTML = [
                '<div class="dwCommonFooter'+ typeClass +'">',
                    '<div class="dwCommonFooter__row">',
                        '<a href="http://www.huanju.cn/s/introduction.html" target="_blank">关于欢聚</a><span class="dwCommonFooter__split">|</span>',
                        '<a href="http://hr.yy.com/" target="_blank">欢聚招聘</a><span class="dwCommonFooter__split">|</span>',
                        '<a href="http://www.huanju.cn/s/contact.html" target="_blank">联系欢聚</a><span class="dwCommonFooter__split">|</span>',
                        '<a href="http://www.huanju.cn/s/links.html" target="_blank">友情链接</a><span class="dwCommonFooter__split">|</span>',
                        '<a href="http://www.huanju.cn/s/contact.html" target="_blank">广告热线：020-29162026</a><span class="dwCommonFooter__split">|</span>',
                        '<a href="http://www.yy.com/go.html#10" target="_blank">客服频道：<strong class="dwCommonFooter__highlight">10</strong></a><span class="dwCommonFooter__split">|</span>',
                        '<a href="http://kf.yy.com" target="_blank">YY客服中心</a><span class="dwCommonFooter__split">|</span>',
                        '<a href="http://www.huanju.cn/1207/m_205349693256.html" target="_blank">隐私权保护政策</a><span class="dwCommonFooter__split">|</span>',
                        '<a href="http://www.huanju.cn/1207/m_205353486825.html" target="_blank">版权保护投诉指引</a><span class="dwCommonFooter__split">|</span>',
                        '<a href="http://www.100.com" target="_blank">100教育</a>',
                    '</div>',
                    '<div class="dwCommonFooter__row">',
                        '<p>',
                            '<span class="dwCommonFooter__txt" target="_blank">增值电信业务经营许可证</span><a href="http://assets.dwstatic.com/common/docs/B2-20050785.jpg">粤B2-20050785</a>',
                            '<a href="http://assets.dwstatic.com/common/docs/B2-20120129.jpg" target="_blank">B2-20120129</a><span class="dwCommonFooter__split">|</span>',
                            '<a href="http://assets.dwstatic.com/common/docs/1910441.jpg" target="_blank">视听许可证1910441号</a><span class="dwCommonFooter__split">|</span>',
                            '<a href="http://assets.dwstatic.com/common/docs/1712-302.jpg?1229" target="_blank">粤网文[2015]1712-302号</a><span class="dwCommonFooter__split">|</span> ',
                            '<span class="dwCommonFooter__txt">举报邮箱：dwkf@yy.com</span> <span class="dwCommonFooter__split">|</span>',
                            ' <span class="dwCommonFooter__txt">举报电话：020-82120010</span>',
                        '</p>',
                        '<p>',
                            '<a href="http://www.miitbeian.gov.cn" target="_blank">粤ICP备09075143号</a><span class="dwCommonFooter__split">|</span>',
                            '<a href="http://assets.dwstatic.com/common/docs/4401060100548.jpg" target="_blank">穗公网监备案证第4401060100548号</a><span class="dwCommonFooter__split">|</span>',
                            '<a href="http://www.gdca.gov.cn/" target="_blank">广东省通信管理局</a><span class="dwCommonFooter__split">|</span>',
                            '<a href="http://assets.dwstatic.com/common/docs/038.jpg" target="_blank">互联网出版许可证</a><span class="dwCommonFooter__split">|</span>',
                            '<a href="http://assets.dwstatic.com/common/docs/01022.jpg" target="_blank">节目制作经营许可证</a><span class="dwCommonFooter__split">|</span>',
                            '<a rel="nofollow" href="javascript:void(0)"><img src="http://www.beian.gov.cn/img/ghs.png" style="vertical-align: middle">粤公网安备 44011302000068号</a>'+
                        '</p>',
                        '<p><span class="dwCommonFooter__txt">广州华多网络科技有限公司 &copy; 2005-'+ thisYear +' Duowan.com 版权所有</span></p>',
                    '</div>',
                    '<div class="dwCommonFooter__row dwCommonFooter__row--approve">',
                        '<a href="http://guangzhou.cyberpolice.cn/netalarm/netalarm/wangjian_index.jsp" target="_blank"><i class="approveIcon1"></i>广州网络警察报警平台</a>',
                        '<a href="http://210.76.65.188/newwebsite/main.jsp?id=4401&adir=&wy=1" target="_blank"><i class="approveIcon2"></i>公共信息安全网络监察</a>',
                        '<a href="http://netadreg.gzaic.gov.cn/ntmm/WebSear/WebLogoPub.aspx?logo=440106106022005041100016" target="_blank"><i class="approveIcon3"></i>工商网监红盾认证</a>',
                        '<a href="http://315web.duowan.com/index.jsp" target="_blank"><i class="approveIcon4"></i>消费维权服务站</a>',
                        '<a href="http://www.net.china.com.cn/txt/2015-01/20/content_7622927.htm" target="_blank"><i class="approveIcon5"></i>网络敲诈有偿删帖</a>',
                        '<a href="http://www.12377.cn/" target="_blank"><i class="approveIcon6"></i>中国互联网举报中心</a>',
                    '</div>',
                    '<div class="dwCommonFooter__row dwCommonFooter__row--logo">',
                        '<a class="dwCommonFooter__huanju" href="http://www.huanju.cn/" target="_blank">欢聚时代</a>',
                        '<span class="dwCommonFooter__logoSplit"></span>',
                        '<a class="dwCommonFooter__huyu" href="http://www.5153.com/" target="_blank">欢聚时代互动娱乐</a>',
                    '</div>',
                '</div>'
            ];
            navHTML = navHTML.join('');
            
            document.writeln(navStyle);
            document.writeln(navHTML);
        },
        
        // 全站公共脚本
        commonScript: function(){
            var scripts = [
                '<script src="http://www.duowan.com/duowan.js"></script>', // 海度统计
                '<script src="http://www.duowan.com/public/s/market_count.js"></script>', // 广告统计
                '<script src="http://www.duowan.com/s/statistics.js"></script>', // 导量统计
                '<script src="http://assets.dwstatic.com/amkit/entry.js" data-entry="p/footer/main"></script>' // 视频处理
            ];
            
            var withoutTvFix = document.getElementById("without-tvfix");
            
            // 如果有#without-tvfix，则去除最后一个脚本
            if (withoutTvFix) {
                scripts.pop();
            }
            
            scripts = scripts.join('');
            
            document.writeln(scripts);
        },
        
        // 全站右下角公共弹窗
        liveTip: function(){
            var withoutGem = document.getElementById("dw-footer-without-gem");
            var mobi =/Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent);
            if (!withoutGem && !mobi) document.writeln('<script src="http://assets.dwstatic.com/amkit/entry.js" data-entry="p/livetip/1.1.0/main"><\/script>');
            withoutGem = null;
        },
        
        // ios设备播放国内视频站视频
        flashTransformForIOS: function(){
            if((navigator.userAgent.match(/iPhone/i)) || (navigator.userAgent.match(/iPod/i)) || (navigator.userAgent.match(/iPad/i))) {
                var embeds  = document.querySelectorAll('embed[src*=swf]'),
                    embedsLength = embeds.length,
                    youkuPattern = /\/sid\/([\w]+)[\W]/,
                    tudouPattern = /\/v\/([^\/]+)\//,
                    sohuPattern  = /id=([\d]+)[\D]/i;
                for (var i = 0; i < embedsLength; i++) {
                    var embedParent = embeds[i].parentNode;
                    var _U = embeds[i].getAttribute('src');
                    var _W = embeds[i].getAttribute('width');
                    var _H = embeds[i].getAttribute('height');
                    if(_U.match(/youku/) && _U.match(youkuPattern)){
                        var vid = _U.match(youkuPattern)[1];
                        if(vid != null){
                            
                            var youkuIframe = document.createElement('iframe');
                            youkuIframe.width = _W;
                            youkuIframe.height = _H;
                            youkuIframe.src = 'http://player.youku.com/embed/' + vid;
                            
                            embedParent.replaceChild(youkuIframe,embeds[i]);
                            
                            youkuIframe = null;
                        };
                    }else if(_U.match(/tudou/) && _U.match(tudouPattern)){
                        var vid = _U.match(tudouPattern)[1];
                        if(vid != null){
                            var tudouIframe = document.createElement('iframe');
                            tudouIframe.width = _W;
                            tudouIframe.height = _H;
                            tudouIframe.src = 'http://www.tudou.com/programs/view/html5embed.action?code=' + vid;
                            
                            embedParent.replaceChild(tudouIframe,embeds[i]);
                            
                            tudouIframe = null;
                        };
                    }else if(_U.match(/sohu/) && _U.match(sohuPattern)){
                        var vid = _U.match(sohuPattern)[1];
                        if(vid != null){
                            var sohuVideo = document.createElement('video');
                            sohuVideo.width = _W;
                            sohuVideo.height = _H;
                            sohuVideo.setAttribute('x-webkit-airplay', 'allow');
                            sohuVideo.setAttribute('preload', true);
                            sohuVideo.setAttribute('controls', true);
                            sohuVideo.src = 'http://my.tv.sohu.com/ipad/'+ vid +'.m3u8';
                            
                            if (embedParent.nodeName === 'OBJECT') {
                                embedParent.parentNode.replaceChild(sohuVideo,embedParent);
                            } else {
                                embedParent.replaceChild(sohuVideo,embeds[i]);
                            }
                            
                            sohuVideo = null;
                        };
                    };
                };
            };
        },
        
        // 初始化
        init: function(){
            this.navigation();
            this.commonScript();
            this.liveTip();
            this.flashTransformForIOS();
        }
    };
    duowanCommonFooter.init();
    
})();

