/*!
 * Test plugin for Editor.md
 *
 * @file        test-plugin.js
 * @author      pandao
 * @version     1.2.0
 * @updateTime  2015-03-07
 * {@link       https://github.com/pandao/editor.md}
 * @license     MIT
 */

(function() {

    var factory = function (exports) {

		var $            = jQuery;           // if using module loader(Require.js/Sea.js).
        var pluginName   = 'tips-dialog';
		exports.testPlugin = function(){
			alert("testPlugin");
		};

		exports.fn.tipsDialog = function(mdurl) {
            var _this       = this;
			var lang        = this.lang;
			var editor      = this.editor;
			var settings    = this.settings;
			var path        = settings.pluginPath + pluginName + "/";
//			var classPrefix = this.classPrefix;
			var dialogName  = 'tips-plugin', dialog;
//			var dialogLang  = lang.dialog.help;

			if (editor.find("." + dialogName).length < 1)
			{			
				var dialogContent = "<div class=\"markdown-body\" style=\"font-family:微软雅黑, Helvetica, Tahoma, STXihei,Arial;height:390px;overflow:auto;font-size:14px;border-bottom:1px solid #ddd;padding:0 20px 20px 0;\"></div>";

				dialog = this.createDialog({
					name       : dialogName,
					title      : '不看会跪的说明',
					width      : '80%',
					height     : 540,
//					mask       : false,
					drag       : settings.dialogDraggable,
					content    : dialogContent,
					lockScreen : settings.dialogLockScreen,
					maskStyle  : {
						opacity         : settings.dialogMaskOpacity,
						backgroundColor : settings.dialogMaskBgColor
					},
					buttons    : {
						close : [lang.buttons.close, function() {      
							this.hide().lockScreen(false).hideMask();
							
							return false;
						}]
					}
				});
//                dialog.load(false);
//                console.log(dialog.loading(false))
                dialog.hide();
                dialog.hideMask();
            dialog = editor.find("." + dialogName);
            dialog.find('.fa-close,.editormd-close-btn').click(function(){
                $('#cms-editormd').css('zIndex',1);
            })
//			this.dialogShowMask(dialog);
//			this.dialogLockScreen();
//                this.hideMask();
//			dialog.hide();
                
            var helpContent = dialog.find(".markdown-body");
                
			if (helpContent.html() === "") 
			{
				$.get(mdurl, function(text) {
					var md = exports.$marked(text);
					helpContent.html(md);
                    
//                    helpContent.find("a").attr("target", "_blank");
				});
			}
			}
            
            return dialog;
		};

	};
    
	// CommonJS/Node.js
	if (typeof require === "function" && typeof exports === "object" && typeof module === "object")
    { 
        module.exports = factory;
    }
	else if (typeof define === "function")  // AMD/CMD/Sea.js
    {
		if (define.amd) { // for Require.js

			define(["editormd"], function(editormd) {
                factory(editormd);
            });

		} else { // for Sea.js
			define(function(require) {
                var editormd = require("./../../editormd");
                factory(editormd);
            });
		}
	} 
	else
	{
        factory(window.editormd);
	}

})();
