define(function(require, exports) {
	var CStorage = require("lib/cstorage/1.0/cstorage");
	var Cookie = require("arale/cookie/1.0.2/cookie");

	var STORAGE_KEY = 'dw_live_tip_closed';

	exports.init = function() {
		CStorage.init();
	};

	exports.getClosedOption = function(callback) {
		CStorage.get(STORAGE_KEY, function(v) {
			var ret = false;
			if (v) {
				if (new Date().getTime() <= parseInt(v, 10)) {
					ret = true;
				} else {
					CStorage.remove(STORAGE_KEY);
				}
			}
			if (Cookie.get(STORAGE_KEY)) {
				ret = true;
			}
			callback(ret);
		});
	};

	exports.setClosedOption = function(closed, maxAge) {
		if (closed) {
			var expTime = new Date().getTime() + (maxAge || 86400) * 1000;
			var val = expTime.toString();
			CStorage.set(STORAGE_KEY, val, function() {
				CStorage.get(STORAGE_KEY, function(v) {
					if (v != val) {
						Cookie.set(STORAGE_KEY, "1", {
							domain: 'duowan.com',
							path: '/',
							expires: new Date(expTime)
						});
					}
				});
			});
		} else {
			CStorage.remove(STORAGE_KEY);
			Cookie.remove(STORAGE_KEY);
		}
	};
});