define(function(require, exports) {
	var $ = require("jquery");
	var Fixed = require("lib/fixed/1.0/fixed");
	var Setting = require("./setting");
	var Stat = require("./stat");

	exports.init = function(html) {
		var liveTipWrap = $(html),
			liveTips = liveTipWrap.find("#dw-live-tips"),
	        tipsSwitch = liveTipWrap.find("[data-tips-role='switch']"),
	        ie = getIEVersion();
	        
        
        var liveTipsInteraction = {
        
	        // 隐藏弹窗
	        _hideTips: function(animate){
	            if (ie !== 6) {
	                if (animate) {
	                    liveTips.animate({
	                        right: "-320px"
	                    }, 300, function() {
	                        tipsSwitch.animate({
	                          right: "0px"  
	                        }, 500);
	                    });
	                } else {
	                    liveTips.css({
	                        right: "-320px"
	                    });
	                    tipsSwitch.css({
	                        right: "0px"
	                    });
	                }
	            } else {
	            	Fixed.off(liveTips);
	                liveTips.hide();
	                tipsSwitch.addClass("dw-live-tips__switch--on").show().css({
	                    right: 0
	                });
	                Fixed.on(tipsSwitch);
	            }
	        },
	        
	        // 初始化
	        _init: function(){
	            var _this = this;
	            liveTipWrap.on("click", "[data-tips-role='toggle']", function(e) {
	                e.preventDefault();
	                _this._hideTips(true);
	                Setting.setClosedOption(true);

					Stat.collapse();
	            });
	        }
	    };
	    
	    liveTipsInteraction._init();

		exports.hide = liveTipsInteraction._hideTips;

		Setting.init();
		Setting.getClosedOption(function(closed) {
			if (closed) {
				liveTipsInteraction._hideTips();
			}
			liveTipWrap.appendTo(document.body);
			if (ie == 6) {
				if (closed) {
					Fixed.on(tipsSwitch);
				} else {
					Fixed.on(liveTips);
				}
			}

			if (!closed) {
				Stat.display();
			}
		});

		Stat.init(liveTips);


		//获取IE版本
		function getIEVersion() {
			var rv = -1;
			if (navigator.appName == 'Microsoft Internet Explorer') {
				var ua = navigator.userAgent;
				var re = new RegExp("MSIE ([0-9]{1,}[\.0-9]{0,})");
				if (re.exec(ua) != null) {
					rv = parseFloat(RegExp.$1);
				}
			} else if (navigator.appName == 'Netscape') {
				var ua = navigator.userAgent;
				var re = new RegExp("Trident/.*rv:([0-9]{1,}[\.0-9]{0,})");  //for IE 11
				if (re.exec(ua) != null) {
					rv = parseFloat(RegExp.$1);
				}
			}
			return rv;
		}

		// 打开（flash用的函数接口）
		window.openTips = function() {
			// var liveTips = $("#dw-live-tips"), tipsSwitch = $("[data-tips-role='switch']"), ie = getIEVersion();
			if (ie !== 6) {
				tipsSwitch.animate({
					right: "-60px"
				}, 200);
				liveTips.animate({
					right: "0px"
				}, 500);
			} else {
				liveTips.show();
				Fixed.on(liveTips);
				Fixed.off(tipsSwitch);
				tipsSwitch.hide();
			}
			Setting.setClosedOption(false);

			Stat.expand();
		};
    
	};
});