! (function () {
    
"use strict";

var Util = {
    _regExpTrim: /^(\s|\u00A0)+|(\s|\u00A0)+$/g,
    trim: function(text) {
        return (text || "").replace(Util._regExpTrim, "");
    },
    isFunction: function(obj) {
        return Object.prototype.toString.call(obj) === "[object Function]";
    },
    createStyleSheet: function(cssText) {
        var stylesheet;
        if (document.createStyleSheet) {
            stylesheet = document.createStyleSheet();
            stylesheet.cssText = cssText;
        } else {
            stylesheet = document.createElement("style");
            stylesheet.appendChild(document.createTextNode(cssText));
            document.getElementsByTagName("head")[0].appendChild(stylesheet);
        }
        return stylesheet;
    },
    getScript: function(url, callback) {
        var head = document.getElementsByTagName("head")[0] || document.documentElement;
        var script = document.createElement("script");
        script.type = "text/javascript";
        script.async = true;
        script.charset = "utf-8";
        script.src = url;
        script.onload = script.onreadystatechange = function() {
            if (!script.readyState || /loaded|complete/.test(script.readyState)) {
                if (Util.isFunction(callback)) {
                    callback();
                }
                script.onload = script.onreadystatechange = null;
                if (script.parentNode) {
                    script.parentNode.removeChild(script);
                }
            }
        };
        head.insertBefore(script, null);
    },
    getCookie : function(name) {
        var cookieValue = null, REG_TRIM = /^(\s|\u00A0)+|(\s|\u00A0)+$/g;
        if (document.cookie && document.cookie != '') {
            var cookies = document.cookie.split(';');
            for (var i = 0; i < cookies.length; i++) {
                var cookie = (cookies[i] || "").replace(REG_TRIM, "");
                if (cookie.substring(0, name.length + 1) == (name + '=')) {
                    cookieValue = decodeURIComponent(cookie.substring(name.length + 1));
                    break;
                }
            }
        }
        return cookieValue;
    },
    setCookie : function(name, value, options) {
        options = options || {};
        if (value === null) {
            value = '';
            options.expires = -1;
        }
        var expires = '';
        if (options.expires && (typeof options.expires == 'number' || options.expires.toUTCString)) {
            var date;
            if (typeof options.expires == 'number') {
                date = new Date();
                date.setTime(date.getTime() + (options.expires * 24 * 60 * 60 * 1000));
            } else {
                date = options.expires;
            }
            expires = '; expires=' + date.toUTCString();
        }
        var path = options.path ? '; path=' + (options.path) : '';
        var domain = options.domain ? '; domain=' + (options.domain) : '';
        var secure = options.secure ? '; secure' : '';
        document.cookie = [name, '=', encodeURIComponent(value), expires, path, domain, secure].join('');
    }
};
initUDB()

// exports interface
var pageUtil= {
    login : function() {
        UDBSDKProxy.openByFixProxy("")
    },
    logout : function() {
        UDBSDKProxy.deleteCookieByFixProxyWithCallBack("")
    },
    init:function(cb, cbCtx){
        console.log(username)
        var username = Util.getCookie('username')
        if(username){
            cb.call(cbCtx, username)
        }
    }
};
window.pageUtil = window.pageUtil || pageUtil;

if (window.jQuery) {
    jQuery(initUDB);
} else {
    Util.getScript("http://assets.dwstatic.com/b=common/js&f=jquery-1.11.1.min.js,jquery-migrate-1.2.1.min.js&20141230", function() {
        jQuery(initUDB);
    });
}
function initUDB(){
    Util.getScript("http://res.udb.duowan.com/js/oauth/udbsdk/proxy/udbsdkproxy.min.js");
}


})()