var version = '';
var path = '/zt/2016dwparty';
// var version = 'debug'

fis.set('project.exclude', ['tpl/**.tmpl']);

/*设置编译范围*/
fis.set('project.files', ['src/**']);

/*设置发布路径*/
fis.match(/^\/src\/(.*)/i, {
    release: version + '/$1', 
    // url: version + '/$1'
});

/*Sprite背景图移到staticPub/images*/
fis.match(/^\/sass\/(.*\.(png|jpg|gif|jpeg))$/i, {
    release: 'img/sprite/$1',
    url: 'img/sprite/$1'
});

/*启用 fis-spriter-csssprites 插件*/
fis.match('::package', {
    spriter: fis.plugin('csssprites',{
        layout: 'matrix',
        margin: 20,
        htmlUseSprite: true,/*开启模板内联css处理*/
        styleReg: /(<style(?:(?=\s)[\s\S]*?["'\s\w\/\-]>|>))([\s\S]*?)(<\/style\s*>|$)/ig
    })
});

fis.match('*.scss', {
    rExt: '.css',
    useSprite: true,
    parser: fis.plugin('node-sass'),
    postprocessor: fis.plugin('autoprefixer', {
        browsers: ['> 1%', 'last 2 versions'],
        cascade: true
    })
}).match('_*.scss', {
    release: false
})

/*对CSS中的图片进行合并，包括html中的内联样式*/
fis.match('*.{css,html,tpl}', {
    useSprite: true,
});

fis.match('*.tmpl', {
    isJsLike: true,
    parser: fis.plugin('utc')
})

/*css压缩*/
fis.match('*.css', {
    optimizer: fis.plugin('clean-css')
});

/*图片文件域名配置*/
fis.media('dev').match('*.{jpg,png,jpeg,gif,css,js}', {
    domain: '../../',
});

fis.media('prod').match('*.{jpg,png,jpeg,gif,css,scss,js,woff,ttf,svg,eot}', {
    domain: 'http://assets.dwstatic.com' + path,
}).match('::package', {
    postpackager: fis.plugin('loader', {
        allInOne: {
            js: function (file) {
                return version + 'js/' + file.filename + ".js";
            }
        }
    })
}).match('*.js', {
  optimizer: fis.plugin('uglify-js',{
    mangle: {
        except: 'exports, module, require, define'
    }
  })
}).match('*.{js,css,png,jpg,gif,swf}', {
    useHash: true
});