seajs.config({
    // paths: {
    //     common : 'http://assets.dwstatic.com/common'
    // },
    alias : {
        // smartMask : './js/smartMask.js'
        smartMask : 'http://assets.dwstatic.com/www/2.0.0/js/smartMask.js'
    }
}).use('$', function($){
    // 全局$
    window.jQuery = window.$ = $;
    var checkCookie = function(cookie){
        var isShowGuide = cookie.get('dw_guide');
        if (!isShowGuide) {
            createMask();
        }
    };
    var createMask = function(){
        seajs.use('smartMask', function(SmartMask){
            var guide = [
                {
                    id : '1',
                    trigger : '.sp-primary-mall',
                    txt : '有了多玩豆，换周边换激活码换点卡...那都不是事！'
                },
                {
                    id : '2',
                    trigger : '.sp-primary-huya, .sp-primary-live, #primary .ui-wonderful',
                    txt : '有了虎牙视频·直播，海量内容有你好看！'
                },
                {
                    id : '3',
                    trigger : '.sp-newgame-newest',
                    txt : '找新游戏看这里，最全最新最快！'
                },
                {
                    id : '4',
                    trigger : '.sp-game-pc',
                    txt : 'PSP、PSVWIIU...应有尽有，你懂的！'
                }
            ];
            var div = $('<div>');
            var guide_body = div.clone().addClass('ui-guide');
            var guide_inner = div.clone().addClass('g-inner');
            var guide_item_template = div.clone().addClass('ui-guide__item').append('<div class="ui-guide__blank"></div><div class="ui-guide__tips"><span></span><div class="ui-guide__btn"><span></span><span></span></div></div>');
            // div.clone().addClass('ui-guide__blank')).append(div.clone().addClass('ui-guide__tips').append(div.clone().addClass('ui-'))
            var guide_config = [];
            var guide_item = $();
            var guide_blank = $();
            var padding = 8;
            var g_inner_left;
            $('body').append(guide_body.append(guide_inner));
            $(guide).each(function(index, step){
                var trigger = $(step.trigger);
                var caption = $();
                trigger.each(function(){
                    var caption_tmp = $(this).prev().filter('.ui-caption');
                    if (caption_tmp.length) {
                        caption = caption.add(caption_tmp);
                    }
                });
                var item = guide_item_template.clone().addClass('ext-step'+step.id).data('origin',trigger.add(caption));
                guide_inner.append(item);
                guide_item = guide_item.add(item);
                guide_blank = guide_blank.add(item.find('.ui-guide__blank'));
                guide_config.push(index);
                var spans = item.find('span');
                spans.eq(0).html(step.txt);
                if (index >= guide.length - 1) {
                    spans.eq(1).addClass('ui-guide__exit').html('结束引导');
                    spans.eq(2).addClass('ui-guide__advice').html('有奖建议')
                    .append($('<a>').attr({
                        href : 'http://bbs.duowan.com/thread-44139698-1-1.html',
                        target : '_blank'
                    }).css({
                        display : 'block',
                        height : '100%'
                    }));
                } else {
                    spans.eq(1).addClass('ui-guide__continue').html('继续>');
                    spans.eq(2).addClass('ui-guide__break').html('退出引导');
                }
            });
            var onReflowHandler = function(){
                g_inner_left = guide_inner.offset().left;
                guide_item.each(function(){
                    var trigger = $(this).data('origin');
                    var init = {
                        top : Infinity,
                        left : Infinity,
                        right : 0,
                        bottom : 0
                    }
                    trigger.each(function(){
                        var offset = $(this).offset();
                        init.top = Math.min(init.top, offset.top);
                        init.left = Math.min(init.left, offset.left);
                        init.right = Math.max(init.right, offset.left + $(this).parent().width());
                        init.bottom = Math.max(init.bottom, offset.top + $(this).height());
                    });
                    var result = {
                        top : init.top - padding,
                        left : init.left - padding - g_inner_left,
                        width : init.right - init.left + padding * 2,
                        height : init.bottom - init.top + padding * 2
                    };
                    $(this).css(result);
                });
            };
            onReflowHandler();
            var guide_mask = new SmartMask({
                wrap : '.ui-guide',
                event : 'none',
                duration : 1200,
                trigger : '.ui-guide__item',
                config : [guide_config]
            });
            $(window).on('resize', function(){
                onReflowHandler();
                guide_mask.resize();
            });
            showGuide(guide_mask, guide_blank);
        });
    };
    var showGuide = function(guide_mask, guide_blank){
        guide_mask.plugin.beforeShow = function(){
            var mask = guide_mask.plugin.mask;
            guide_blank.each(function(){
                mask[mask.length] = this;
                mask.length++;
            });
        }
        var guide_index = 0;
        var guide = $('.ui-guide');
        var guide_tips = guide.find('.ui-guide__tips');
        var html = $('body,html');
        var scrolling = false;
        var next = function(){
            var now = $(window).scrollTop();
            var current = guide_blank.eq(guide_index);
            if (!current.length) {
                end();
                return
            }
            if (scrolling) {
                return
            }
            scrolling = true;
            var distance = current.parent().offset().top - $(window).height()/2 + current.height()/2;
            if (guide_index) {
                guide_blank.eq(guide_index-1).animate({
                    'opacity' : 0.7
                });
                guide_tips.eq(guide_index-1).fadeOut();
            } else {
                guide_mask.show(guide_index);
            }
            var showTips = function(){
                guide_blank.eq(guide_index).stop().animate({
                    opacity : 0
                });
                guide_tips.eq(guide_index).fadeIn();
                guide_index++;
            };
            html.animate({
                scrollTop : distance
            }, 300 + (Math.abs(distance - now))/2, 'linear', function(){
                showTips();
                showTips = function(){};
                scrolling = false;
            });
        };
        var end = function(){
            guide_mask.plugin.afterHide = function(){
                guide.hide();
                $.cookie('dw_guide','1',{
                    expires : 1
                });
            };
            guide_mask.plugin.duration = guide_mask.plugin.duration/2;
            guide_tips.fadeOut(guide_mask.plugin.duration/2);
            guide_mask.hide();
            $(document).off('keydown', onKeydownHandler);
            $('.ui-backtotop').trigger('click');
        };
        $('.ui-guide').on('click', '.ui-guide__continue', next)
        .on('click', '.ui-guide__break, .ui-guide__exit', end)
        .on('click', '.ui-guide__advice', end);
        // $(next);
        next();
        var onKeydownHandler = function(e){
            if (e.keyCode == 13) {
                // 下一步
                next();
            } else if (e.keyCode == 27) {
                // 退出
                end();
            }
        };
        $(document).on('keydown', onKeydownHandler);
        // window.n = next;
    };
    seajs.use('arale/cookie/1.0.2/cookie', checkCookie);
});
/*
  keywords auto complete
  `syntax`
    return arguments typeof instanceof while switch case catch finally throw void break default debugger NaN Infinity parseInt parseFloat
  `javascript`
    window location replace hash search pathname port hostname origin href navigator platform userAgent clearTimeout clearInterval history back localStorage
    document domain documentElement head body title
    querySelector querySelectorAll getElementById getElementsByTagName getElementsByClassName
    appendChild insertBefore createElement removeChild
    attributes className style innerHTML innerText innerHeight innerWidth
    addEventListener removeEventListener click mouseover mousemove mouseout focus blur change input select submit reset input propertychange resize scroll touchstart touchmove touchend keydown keypress keyup transitionEnd stopPropagation preventDefault
    Object valueOf toString keys constructor
    Array indexOf push pop shift unshift slice splice split join sort reverse
    bind apply call __defineGetter__ __defineSetter__ __lookupGetter__ __lookupSetter__ __proto__
    Math random floor round ceil
    Date getTime getSeconds getMinutes getHours getSeconds getDate getDay getDay getMonth getFullYear
    JSON stringify parse
    RegExp global
    XMLHttpRequest send
    canvas getContext
    null
    undefined
    true false
  `jQuery`
    选择器 even odd gt lt root target contains empty hidden visible radio chechbox reset button file enabled disabled checked selected
    核心 length index data
    ajax get getJSON post serialize serializeArray beforeSend error success complete
    属性 attr removeAttr addClass removeClass toggleClass html text val
    css offset height width
    文档处理 append appendTo prepend prependTo after before insertAfter remove clone
    效果 show hide toggle fadeIn fadeOut
    工具 each extend parseJSON
    筛选 eq first last hasClass filter is map has not slice children closest find next offsetParent parent parents prev siblings add
    延迟对象 done fail promise always notify progress state
  `custom`
    active disabled selected
  `seajs`
    require exports module define async
*/