seajs.config({
    paths: {
        common : 'http://assets.dwstatic.com/common'
    },
    alias : {
        udb : 'common/js/dwudbproxy.js',
        json2 : 'common/lib/json2/20150503/json2.min.js',
        moment : 'common/lib/moment.js/2.10.3/moment.min.js',
        lazyload : 'common/lib/jquery-lazyload/1.9.1/jquery.lazyload.min.js',
        popbox : 'http://assets.dwstatic.com/project/dwpodbg/1.0.0/js/popbox.js',
        placeholder : 'common/lib/jquery-placeholder/0.2.4/jquery.placeholder.min.js',
        'mediaelementplayer':'http://v.duowan.com/sea-modules/mediaelement-and-player-duopai.min.js'
    }
}).use('$', function($){
    // 全局$
    window.jQuery = window.$ = $;

    // 宽窄屏状态
    var isNarrow = $('body').hasClass('g-narrow');

    // ie 禁止默认事件
    $(document).on('click', 'a[href="javascript:"]', function(){
        return false
    });

    var tuku_tab_wrap = $('[data-role="tab-sidebar-tuku"]');
    tuku_tab_wrap.find('[data-switchable-role="nav"]').find('a').on('mouseover',function(){
        var index = $(this).index();
        tuku_tab_wrap.find('[data-switchable-role="nav"]').find('a').removeClass('is-active');
        $(this).addClass('is-active');
        tuku_tab_wrap.find('[data-switchable-role="content"]').find('.tab-cont')
            .addClass('tuku-hide')
            .eq(index).removeClass('tuku-hide')
    })

    // 接入udb系统
    seajs.use('udb', function(){
        if (dwUDBProxy.isLogin()) {
            $(document).on('udb', function(){
                $(document).trigger('udb:login');
                // .off('udb:login');
            }).trigger('udb');
        }
        $('[data-role="login"]').click(function(){
            dwUDBProxy.login('');
        });
        $('[data-role="logout"]').click(function(){
            dwUDBProxy.logout('');
        });
    });

    // 顶栏登录状态
    $(document).one('udb:login', function(){
        $('.udb-default').hide();
        $('.udb-login').show();
        $('[data-role="username"]').html(dwUDBProxy.getCookie('username'));
    }).trigger('udb');

    // 图片懒加载
    seajs.use('lazyload', function(){
        if (window.devicePixelRatio > 1) {
            $('.js-lazy img[data-original-2x]').each(function(){
                $(this).attr({
                    'data-original' : $(this).attr('data-original-2x')
                });
            });
        }
        if (!$.fn.lazyload) {
            $.fn.lazyload = window.$.fn.lazyload || window.jQuery.fn.lazyload;
        }
        $('.js-lazy img').lazyload({
            failurelimit : 5,
            skip_invisible : false
        });
    });

    // 顶栏多玩豆商城浮层
    seajs.use('p/dwpod/1.0.5/dwpod', function(DwpodWin){
        $(document).one('udb:login', function(){
            // pod浮层异步生成
            var pod = $('.ui-topbar .ext-mission').attr('id','pod');
            var tasksBoard = DwpodWin('#pod', function(){
                // checkinCallback 签到成功回调
                $().getData(primary_mall_domain + '?r=home/Getmission&type=jsonp',true);
            });
            pod.on('mouseenter', function(){
                if (tasksBoard.children().length > 1) {
                    tasksBoard.show();
                }
            }).on('mouseleave', function(e){
                tasksBoard.hide();
            });
        }).trigger('udb');
    });

    // 搜索栏使用placeholder
    seajs.use('placeholder', function(){
        if (!$.fn.placeholder) {
            $.fn.placeholder = window.$.fn.placeholder || window.jQuery.fn.placeholder;
        }
        var form = $('.ui-search form');
        var input = form.find('input[placeholder]');
        input.placeholder();
        var defaults = input.attr('placeholder');
        form.on('submit', function(){
            if (input.val() == '') {
                input.val(defaults);
                setTimeout(function(){
                    input.val('');
                },0);
            }
        });
    });


    // `页面可见性` 切换时的事件监听
    var pageVisibility = (function() {
        var prefixSupport, keyWithPrefix = function(prefix, key) {
            if (prefix !== '') {
                // 首字母大写
                return prefix + key.slice(0,1).toUpperCase() + key.slice(1);
            }
            return key;
        };
        var isPageVisibilitySupport = (function() {
            var support = false;
            if (typeof window.screenX === 'number') {
                ['webkit', 'moz', 'ms', 'o', ''].forEach(function(prefix) {
                    if (support == false && document[keyWithPrefix(prefix, 'hidden')] != undefined) {
                        prefixSupport = prefix;
                        support = true;
                    }
                });
            }
            return support;
        })();

        var isHidden = function() {
            if (isPageVisibilitySupport) {
                return document[keyWithPrefix(prefixSupport, 'hidden')];
            }
            return undefined;
        };

        var visibilityState = function() {
            if (isPageVisibilitySupport) {
                return document[keyWithPrefix(prefixSupport, 'visibilityState')];
            }
            return undefined;
        };

        return {
            hidden: isHidden(),
            visibilityState: visibilityState(),
            visibilitychange: function(fn, usecapture) {
                usecapture = usecapture || false;
                if (isPageVisibilitySupport && typeof fn === 'function') {
                    $(document).one('visibilitychange:once', fn);
                    return document.addEventListener(prefixSupport + 'visibilitychange', function(evt) {
                        this.hidden = isHidden();
                        this.visibilityState = visibilityState();
                        fn.call(this, evt);
                    }.bind(this), usecapture)
                }
                // return undefined
            }
        }
    })();

    // 焦点图交互
    seajs.use('arale/switchable/1.0.2/carousel', function(Carousel) {
        var slide_primary = new Carousel({
            element: '[data-role="slide-primary"]',
            classPrefix: null,
            activeTriggerClass: 'is-active',
            autoplay: false,
            effect: 'scrollx'
        }).render();
        var slide_tuku1 = new Carousel({
            element: '[data-role="slide-tuku"]',
            classPrefix: null,
            activeTriggerClass: 'is-active',
            autoplay: false,
            effect: 'scrollx'
        }).render();
        var slide_tuku2 = new Carousel({
            element: '[data-role="slide-tuku2"]',
            classPrefix: null,
            activeTriggerClass: 'is-active',
            autoplay: false,
            effect: 'scrollx'
        }).render();
        var slide_tuku3 = new Carousel({
            element: '[data-role="slide-tuku3"]',
            classPrefix: null,
            activeTriggerClass: 'is-active',
            autoplay: false,
            effect: 'scrollx'
        }).render();
        var slide_tuku4 = new Carousel({
            element: '[data-role="slide-tuku4"]',
            classPrefix: null,
            activeTriggerClass: 'is-active',
            autoplay: false,
            effect: 'scrollx'
        }).render();
        // 要闻轮播图
        if (window._compatible) {
            var slide_primary_btn = slide_primary.element.hover(function(){
                slide_primary_btn.show();
            },function(){
                slide_primary_btn.hide();
            }).find('.ui-slide__prev,.ui-slide__next');
            return
        }
        var width_narrow = 330;
        var width_wide = 548;
        var height = 345;
        var width = isNarrow ? width_narrow : width_wide;
        var duration = 6000;
        var body = $('body');
        var isHover = false;
        var isStop = false;
        var isSupportCSS3 = typeof body.css('transition') != 'undefined';
        var isSupportIE = true;
        // var property = 'backgroundPositionX';
        var property = 'left';
        var progressbar = {
            element : slide_primary.element.find('.ui-slide__progress i'),
            callback : function(){
                $(this).css(progressbar.init);
                slide_primary.next();
                // console.log('slide: rolling!'); //%% 提示切换中
            },
            start : function(){
                // return
                if (!isSupportCSS3 && isSupportIE) {
                    progressbar.element.stop().animate(progressbar.target,
                        duration * progressbar.percentage(), 'linear', progressbar.callback);
                }
            },
            reset : function(){
                if (!isSupportCSS3 && isSupportIE) {
                    progressbar.element.stop().css(progressbar.init);
                }
            },
            stop : function(){
                if (!isSupportCSS3 && isSupportIE) {
                    progressbar.element.stop();
                }
            },
            percentage : function(){
                return (Math.abs(parseInt(progressbar.element.css(property)))/width).toFixed(2)-0
            },
            init : {},
            target : {},
            start_css3 : function(){
                // 低版本webkit 不支持 transform 则使用all
                progressbar.element.css('transition','all '+duration+'ms linear').addClass('is-moving');
            },
            reset_css3 : function(){
                // 低版本webkit 不支持 transform 则使用all
                progressbar.element.css('transition','all '+0+'ms linear').removeClass('is-moving');
            }
        };
        // progressbar.init[property] = -width;
        // progressbar.target[property] = 0;
        progressbar.init[property] = '-100%';
        progressbar.target[property] = '0%';
        var current_index = slide_primary.element.find('.ui-slide__total em').html(slide_primary.get('panels').length+'').end().find('.ui-slide__current').html('1');
        current_index.parent().show();
        slide_primary.on('change:activeIndex', function(toIndex, fromIndex){
            current_index.html(toIndex+1);
            !isHover && setTimeout(isSupportCSS3 ? progressbar.start_css3 : progressbar.start,0);
        }).element.hover(function(){
            if (isSupportCSS3) {
                progressbar.reset_css3();
            } else {
                progressbar.reset();
            }
            // console.log('slide: stop cause hover'); //%% 提示因为hover而暂停
            isHover = true;
        },function(){
            if (isSupportCSS3) {
                progressbar.start_css3();
            } else {
                progressbar.start();
            }
            // console.log('slide: start cause hoverout'); //%% 提示因为hover out而开始
            isHover = false;
        });
        var timeoutId = 0;
        // 支持css3 不进行resize/scroll/visibility 监听
        if (isSupportCSS3) {
            progressbar.element.on('transitionend webkitTransitionEnd', function(){
                progressbar.reset_css3();
                slide_primary.next();
            });
            progressbar.start_css3();
        } else {
            $(window).on('resize', function(){
                // 页面大小改变时 先暂停计时进度
                if (!isStop) {
                    clearTimeout(timeoutId);
                    progressbar.stop();
                    // console.log('slide: stop cause resizing'); //%% 提示因为拉伸窗口而暂停
                    timeoutId = setTimeout(progressbar.start,200);
                }
            });
            progressbar.start();
            $(window).on('scroll', function(){
                var now = $(window).scrollTop();
                var screen_top = now - height;
                var screen_bot = now + $(window).height();
                var base_top = slide_primary.element.offset().top;
                // console.log(base_top, screen_top, screen_bot, isStop); //%% 提示窗口数据与暂停状态
                // 页面滚动时 越过临界点触发
                if ((base_top > screen_bot || base_top < screen_top) && !isStop) {
                    progressbar.stop();
                    // console.log('slide: stop cause leave'); //%% 提示因为离开可视区域而暂停
                    isStop = true;
                } else if (!(base_top > screen_bot || base_top < screen_top) && isStop) {
                    progressbar.start();
                    // console.log('slide: start cause appear'); //%% 提示因为进入可视区域而开始
                    isStop = false;
                }
            }).trigger('scroll');
            // 离开页面时 暂停
            if (pageVisibility.visibilityState) {
                var isPause = false;
                pageVisibility.visibilitychange(function(){
                    if (pageVisibility.hidden && !isStop) {
                        progressbar.stop();
                        // console.log('slide: pause cause hidden'); //%% 提示因为离开页面而暂停
                        isPause = true;
                    } else if (!pageVisibility.hidden && isPause) {
                        progressbar.start();
                        // console.log('slide: continue cause back'); //%% 提示因为返回页面而开始
                        isPause = false;
                    }
                });
            }
        }
        $(window).on('resize:narrow', function(){
            width = width_narrow;
            slide_primary.content.css('left', parseInt(slide_primary.content.css('left'))*width_narrow/width_wide);
            slide_primary.set('viewSize',[width_narrow, height]).render();
        }).on('resize:wide', function(){
            width = width_wide;
            slide_primary.content.css('left', parseInt(slide_primary.content.css('left'))*width_wide/width_narrow);
            slide_primary.set('viewSize',[width_wide, height]).render();
        });
    });


    // 选项卡交互
    seajs.use('arale/switchable/1.0.2/tabs', function(Tab) {
        var defaults = {
            classPrefix: null,
            activeTriggerClass: 'is-active'
        };
        var onChangeHandle = function(toIndex, fromIndex) {
            var activePanel = $(this.get('panels')[toIndex]),
                lazyArea = activePanel.find('textarea[data-role="lazy"]');
            if (toIndex !== 0 && lazyArea.length > 0) {
                var lazyHTML = lazyArea.val();
                activePanel.html(lazyHTML);
            }
        };
        var createTab = function(i, role){
            var selector = '[data-role="'+role+'"]';
            var tips__triggers = $(selector).find('.ui-tab__trigger.ui-tips__trigger');
            if (tips__triggers.length) {
                tips__triggers.each(function(){
                    var tips_onMouseoverHandler = $(this).data('tips');
                    if (tips_onMouseoverHandler) {
                        $(this).off('mouseover', tips_onMouseoverHandler);
                    } else {
                        $(this).data('tips', true);
                    }
                }).on('mouseover', function(){
                    if ($(this).hasClass('is-active')) {
                        $(this).trigger('mouseover:tips');
                    }
                });
            }
            // 监听一次 mouseover 事件 用户使用选项卡才对选项卡初始化
            // js-loading 需要等待 数据接口 暂停监听
            $(selector).one('mouseover', '.ui-tab__trigger:not(.js-loading)', function(){
                var tab = new Tab($.extend({}, defaults, {element: selector})).on('change:activeIndex', onChangeHandle);
                if (tips__triggers.length) {
                    // 存在悬浮层组件时 把`显示悬浮层`的逻辑 移在 `切换面板`的逻辑之后
                    // 需要取消 原事件 监听 并且通过 change:activeIndex 监听
                    tab.on('change:activeIndex', function(toIndex, fromIndex){
                        $(this.get('triggers')[toIndex]).trigger('mouseover:tips');
                    });
                }
                var index = $(this).index();
                index&&tab.set('activeIndex',index);
            });
        };
        $([
            'tab-nav',
            'tab-primary-privilege',
            'tab-primary-news',
            'tab-sidebar-tip'
        ]).each(createTab);
        // 统一初始化选项卡


    });

    // 引入cookie插件
    seajs.use((typeof JSON == 'undefined' ? ['arale/cookie/1.0.2/cookie','json2'] : ['arale/cookie/1.0.2/cookie']), function(cookie){
        $.extend({
            cookie : function(id){
                id = id.replace(/=/g, '');
                if (arguments.length == 1) {
                    return cookie.get(id)
                } else {
                    return cookie.set.apply(cookie, arguments)
                }
            }
        });
        var cache = $(document).data('cookie')||{};
        for (var id in cache) {
            var data = cache[id];
            $.cookie(id, JSON.stringify(data), { expires : 1 });
        }
    });

    // 统一数据缓存方式
    $.extend({
        setCache : function(id, data){
            // return window.localStorage ? (window.localStorage.setItem(id, JSON.stringify(data))) : $.cookie(id, JSON.stringify(data), { expires : 1})
            // 缓存1天
            // cookie 未加载前 则用 document 缓存
            if (typeof $.cookie == 'function') {
                $.cookie(id, JSON.stringify(data), { expires : 1 });
            } else {
                var cache = $(document).data('cookie')||{};
                cache[id] = data;
                $(document).data('cookie', cache);
            }
            return this
        },
        getCache : function(id){
            // return window.localStorage ? (JSON.parse(window.localStorage.getItem(id))) : $.cookie(id)
            if (typeof $.cookie == 'function') {
                var data = $.cookie(id);
                if (data) {
                    return JSON.parse(data)
                }
            } else {
                var cache = $(document).data('cookie')||{};
                return cache[id]
            }
        }
    });

    // 统一数据填充方式(基于lego ui结构)
    (function(){
        var link = function(href, title){
            this.href = this.find('a').attr({
                href : href,
                title : title ? title : ''
            });
            return this
        }
        var list = function(data){
            this.name = this.find('.ui-list__name');
            this.game = this.find('.ui-list__game');
            this.number = this.find('.ui-list__number');
            this.other = this.find('.ui-list__other');
            this.link = this.find('.ui-list__link');
            this.date = this.find('.ui-list__date');
            this.status = this.find('.ui-list__status');
            this.platform = this.find('.ui-list__platform');
            this.type = this.find('.ui-list__type');
            this.meta = this.find('.ui-list__meta');
            this.rank = this.find('.ui-list__rank');
            if (data.name) {
                this.name.html(data.name);
            }
            if (data.game) {
                this.game.append($('<a>').html(data.game));
            }
            if (data.number) {
                this.number.html(data.number);
            }
            if (data.other) {
                this.other.html(data.other);
            }
            if (data.link) {
                this.link.html(data.link);
            }
            if (data.date) {
                this.date.html(data.date);
            }
            if (data.status) {
                this.status.html(data.status);
            }
            if (data.platform) {
                this.platform.html(data.platform);
            }
            if (data.type) {
                this.type.html(data.type);
            }
            if (data.meta) {
                this.meta.html(data.meta);
            }
            if (data.rank) {
                this.rank.html(data.rank);
            }
            return link.call(this, data.href, data.tit)
        }
        var media = function(data){
            this.tit = this.find('.ui-media__tit').html(data.tit);
            this.img = this.find('.ui-media__img').attr({
                src : data.img,
                alt : data.alt ? data.alt : ''
            });
            this.txt = this.find('.ui-media__txt').html(data.txt);
            return link.call(this, data.href, data.tit)
        }
        var figure = function(data){
            this.img = this.find('.ui-figure__img').attr({
                src : data.img,
                alt : data.alt ? data.alt : ''
            });
            this.caption = this.find('.ui-figure__caption');
            this.mask = this.find('.ui-figure__mask');
            this.sign = this.find('.ui-figure__sign');
            this.meta = this.find('.ui-figure__meta');
            this.name = this.find('.ui-figure__name');
            this.view = this.find('.ui-figure__view');
            this.tag = this.find('.ui-figure__tag');
            this.author = this.find('.ui-figure__author');
            if (data.caption) {
                this.caption.html(data.caption);
            }
            if (data.mask) {
                this.mask.html(data.mask);
            }
            if (data.sign) {
                this.sign.html(data.sign);
            }
            if (data.meta) {
                this.meta.html(data.meta);
            }
            if (data.name) {
                this.name.html(data.name);
            }
            if (data.view) {
                this.view.html(data.view);
            }
            if (data.tag) {
                this.tag.html(data.tag);
            }
            if (data.author) {
                this.author.attr({
                    src : data.author,
                    alt : data.author_alt ? data.author_alt : ''
                });
            }
            return link.call(this, data.href, data.tit)
        }
        $.fn.extend({
            lego : function(){
                if (this.length == 1) {
                    this.list = list;
                    this.media = media;
                    this.figure = figure;
                }
                // 只允许对单个item对象作处理
                return this
            }
        });
    })();

    // 数据模板缓存对象(基于lego ui结构)
    // 公共方法 修正数量单位
    (function(){
        var lego = {
            caption_ext : $('<li>').addClass('ui-lineList__item').append($('<a>')),
            tab_trigger : $('<li>').addClass('ui-tab__trigger js-loading').append($('<a>').attr('href','javascript:')),
            tab_panel : $('<div>').addClass('ui-tab__panel u-hide'),
            formatView : function(val){
                val = val ? val - 0 : 0;
                if (val > 10000) {
                    val = (val/10000).toFixed(1) + '万'
                }
                return val
            }
        }
        $.extend({ lego : lego });
    })();

    // 统一数据请求方式
    (function(){
        var memory = {};
        window.memory = memory;
        // 禁止ie缓存
        $.ajaxSetup({
            cache : false
        });
        // log方法
        function log () {
            if (window.console && console.log) {
                var msg = Array.prototype.join.call(arguments, ' ');
                console.log.call(console, '%c' + msg, 'color:#ff241a');
            }
        }
        $.fn.extend({
            getData : function(url, noCache,callbackname){
                var request = memory[url];
                if (this.length) {
                    this.data('data-request', arguments);
                    // 该url如果已请求 则不重复请求
                    if (!request) {
                        // console.log('first get >> ' + url); //%% 提示该接口开始请求
                        request = memory[url] = {
                            done : false,
                            fail : false,
                            list : this
                        };
                        var data;
                        $.ajax({
                            url: url,
                            type: 'get',
                            timeout: 5000,
                            dataType: 'jsonp',
                            jsonp: callbackname || 'callback'
                        }).done(function(result, status){
                            if (status == 'success') {
                                data = result;
                            }
                        }).always(function(){
                            if (!data) {
                                // 有时效性的接口 不取缓存
                                if (!noCache) {
                                    data = $.getCache(url);
                                }
                                // 接口请求失败并且无缓存 触发报错事件
                                if (!data) {
                                    request.fail = true;
                                    request.list.trigger('data:fail');
                                    return
                                }
                            } else {
                                // 有时效性的接口 不缓存
                                if (!noCache) {
                                    $.setCache(url, data);
                                }
                            }
                            request.done = true;
                            // 捕捉接口异常
                            try {
                                // 测试
                                // request.list.trigger('data:fail');
                                request.list.trigger('data:entry', {
                                    data : data
                                });
                            } catch (err) {
                                var stack = err.stack||'';
                                var line = stack.match(/\(.*\)/)||[];
                                log(err.message, line[0]||'', url);
                            }
                            request.data = data;
                        });
                    } else {
                        // console.log('same get >> ' + url); //%% 提示该接口已请求
                        // 该url如果已请求 并且获得结果则马上 执行回调 否则添加到等待队列
                        if (request.done) {
                            try {
                                // 测试
                                // this.trigger('data:fail');
                                this.trigger('data:entry', {
                                    data : memory[url].data
                                });
                            } catch (err) {
                                var stack = err.stack||'';
                                var line = stack.match(/\(.*\)/)||[];
                                log(err.message, line[0]||'', url);
                            }
                        } else if (request.fail) {
                            // 请求超时则 触发报错事件
                            this.trigger('data:fail');
                        }
                        request.list = request.list.add(this);
                    }
                } else {
                    // 没有对象 则代表 刷新该url
                    var data;
                    $.ajax({
                        url: url,
                        type: 'get',
                        timeout: 5000,
                        dataType: 'jsonp',
                        jsonp: 'callback'
                    }).done(function(result, status){
                        if (status == 'success') {
                            data = result;
                        }
                    }).always(function(){
                        if (!data) {
                            // 接口请求失败 触发报错事件
                            if (!data) {
                                request.fail = true;
                                request.list.trigger('data:fail');
                                return
                            }
                        } else {
                            // 有时效性的接口 不缓存
                            if (!noCache) {
                                $.setCache(url, data);
                            }
                        }
                        request.done = true;
                        // 捕捉接口异常
                        try {
                            request.list.trigger('data:refresh', {
                                data : data
                            }).trigger('data:entry', {
                                data : data
                            });
                        } catch (err) {
                            var stack = err.stack||'';
                            var line = stack.match(/\(.*\)/)||[];
                            log(err.message, line[0]||'', url);
                        }
                        request.data = data;
                    });
                }
                return this
            }
        });
    })();

    // 统一数据加载失败事件句柄
    var onDataFailHandler = function(e){
        // 传入 classname 才插入 fail 面板
        if (e.data && e.data.classname) {
            if ($(this).addClass('ui-fail').is('ul')) {
                var tips = $('<li>');
            } else {
                var tips = $('<div>');
            }
            if ($(this).css('position') == 'static') {
                $(this).css('position', 'relative');
            }
            tips.addClass('ui-fail__bd').append('<i class="ui-fail__icon"></i><p class="ui-fail__tips">服务器君歇息了，刷新试试</p><span class="ui-fail__refresh" data-role="fail-refresh">刷新</span>').addClass(e.data.classname).appendTo($(this));
            // 存在 callback 则执行
            if (e.data.callback) {
                e.data.callback.call(tips);
            }
        }
        return false
    };

    // 统一数据刷新事件句柄
    var onDataRefreshHandler = function(){
        var fail = $(this).filter('.ui-fail');
        fail = fail.add($(this).find('.ui-fail'));
        fail.removeClass('ui-fail').find('.ui-fail__bd').remove();
        return false
    };

    // 数据加载失败 刷新按钮事件委托
    $(document).on('click', '[data-role="fail-refresh"]', function(){
        $.fn.getData.apply($(), $(this).closest('[data-entry]').trigger('data:refresh').data('data-request'));
    });

    // 数据加载
    var huya_domain = 'http://www.huya.com/cache.php?m=DuowanIndex';
    var huya_hosts = 'http://www.huya.com/';
    var huya_origin = '?from=duowan';
    // 首屏虎牙直播 数据入口 [data-entry="primary-live"] 覃永婷/黄湘
    $('[data-entry="primary-live"]').on('data:entry', function(e, result){
        var primary_live = $(this);
        var primary_live_data = result.data.data['b_0'][2][0].livedatas;
        primary_live.find('.ui-banner-box').each(function(index){
            var item = $(this);
            var item_data = primary_live_data[index];
            var item_figure = item.lego().figure({
                caption : item_data.nick,
                img : item_data.pic,
                alt : item_data.title,
                sign : item_data.gameFullName,
                meta : (item_data.totalCount||0)+'在线',
                href : huya_hosts+item_data.privateHost+huya_origin,
                tit : item_data.title
            });
            item_figure.tag.show();
        });
        primary_live.find('.ui-figure__item').each(function(index){
            var item = $(this);
            var item_data = primary_live_data[index];
            var item_figure = item.lego().figure({
                caption : item_data.nick,
                img : item_data.pic,
                alt : item_data.title,
                sign : item_data.gameFullName,
                meta : (item_data.totalCount||0)+'在线',
                href : huya_hosts+item_data.privateHost+huya_origin,
                tit : item_data.title
            });
            item_figure.tag.show();
        });
        primary_live.find('.ui-loading').removeClass('ui-loading');
    }).on('data:fail', {
        classname : 'ext-center',
        callback : function(){
            this.css('marginTop',-20);
            var parent = this.parent();
            if (parent.css('overflow')=='hidden') {
                parent.css('overflow','visible')
            }
        }
    }, function(){
        var self = this;
        var args = arguments;
        // 通过 seajs 实现 异步when功能 避免repaint延迟
        define('local[primay-live]', function(){
            onDataFailHandler.apply(self, args);
        });
        // 当两个模块都定义后 执行use
        if (seajs.cache[seajs.resolve('local[primay-live-wonderful]')]) {
            seajs.use(['local[primay-live]', 'local[primay-live-wonderful]']);
        }
    }).on('data:refresh', function(){
        var ret = onDataRefreshHandler.apply(this, arguments);
        $(this).css('overflow','');
        return ret
    }).getData(huya_domain, true);



    //首页咨询接口对接 卢嘉华
    var main_list_url = "http://home.webdev.duowan.com/index.php?r=default/Ajax";//http://dwapi.duowan.com/index.php?r=default/Ajax
    //初始化
    $('#main-news-list-wrap').find('.add-list-more').on('click',function(){
        var _this = $(this),main_list_wrap = _this.parent(),
            main_list_tag = _this.data('tag'),
            main_list_page = _this.data('page') || 1;
        _this.hide();
        main_list_wrap.find('.ui-loading').show();
        $.ajax({
            url: main_list_url,
            data:{
                tag:main_list_tag,
                p:main_list_page
            },
            type: 'get',
            timeout: 5000,
            dataType: 'jsonp',
            jsonp: 'callback'
        }).done(function(data){
            if(data.code==200){
                var  main_list = data.data.news,tempListArr=[],i
                if(main_list.length>0){
                    for(i in main_list){
                        var hotword = hotWordArr(main_list[i].hotword)
                        if( main_list[i].showType == "图集"){
                            tempListArr.push('<div class="main-news-list main-news-list-img"><div class="news-img-wrap">' +
                                '<a href="'+main_list[i].url+'" title="'+main_list[i].title+'" target="_blank" class="u-clearfix">' +
                                '<p class="news-intro-title">'+main_list[i].title+'</p>' +
                                '<img src="http://assets.dwstatic.com/common/img/blank.png" data-original="'+main_list[i].atlas[0]+'" alt="">' +
                                '<img src="http://assets.dwstatic.com/common/img/blank.png" data-original="'+main_list[i].atlas[1]+'" alt="" class="news-img-mid">' +
                                '<img src="http://assets.dwstatic.com/common/img/blank.png" data-original="'+main_list[i].atlas[2]+'" alt=""></a>' +
                                '</div><div class="news-intro"><div class="news-intro-tag">'+main_list[i].author+''+hotword+'</div>' +
                                '<div class="news-intro-comment"><i class="i-news-comment"></i>'+main_list[i].comment+'</div></div></div>')
                        }else{
                            if( main_list[i].showType != "纯文本"){
                                //单图
                                tempListArr.push('<div class="main-news-list"><div class="news-img-wrap"><a href="'+main_list[i].url+'" title="'+main_list[i].title+'" target="_blank"><img src="http://assets.dwstatic.com/common/img/blank.png" data-original="'+main_list[i].atlas[0]+'" alt=""></a></div>' +
                                    '<div class="news-intro"><p class="news-intro-title"><a href="">'+main_list[i].title+'</a></p>' +
                                    '<div class="news-intro-tag">'+main_list[i].author+''+hotword+'</div>' +
                                    '<div class="news-intro-comment"><i class="i-news-comment"></i>'+main_list[i].comment+'</div></div></div>')
                            }else{
                                //纯文本
                                var news_intro = "";
                                if(main_list[i].digest.length>0){
                                    news_intro += '<blockquote><ahref="'+main_list[i].url+'" title="'+main_list[i].title+'" target="_blank">'+main_list[i].digest+'<span>[领取福利]</span></a></blockquote>'
                                }
                                tempListArr.push('<div class="main-news-list main-news-list-ad">' +
                                    '<p class="news-intro-title"><a href="'+main_list[i].url+'" title="'+main_list[i].title+'" target="_blank"><i class="i-news-ad"></i>'+main_list[i].title+'</a></p>'+news_intro+'</div>');
                            }

                        }
                    }

                    $(tempListArr.join("")).insertBefore(_this);
                    //页码加1
                    main_list_page++;
                    _this.data('page',main_list_page);
                    $('.js-lazy img').lazyload({
                        failurelimit : 5,
                        skip_invisible : false
                    })
                }else{
                    _this.html('已加载完毕')
                }

                _this.show();
                main_list_wrap.find('.ui-loading').hide();
            }
        })
    })
    /**
     * 处理热词
     * @param arr
     * @returns {string}
     */
    function hotWordArr(arr){
        var hotword = "";
        for(var j in arr){
            hotword+='<a href="'+arr[j].url+'" target="_blank">'+arr[j].tag+'</a>'
        }
        return hotword
    }



    //侧边栏专区内容筛选
    $('.main-nav a').on('click',function(){
        var _this = $(this),index = _this.parent().index(),
            huya_id = _this.attr('huya-id') || 0,
            zq_href =  _this.attr('zq-href') || "",
            sjt_id = _this.attr('sjt-id'),
            bbs_id = _this.attr("bbs-id") || "";
        var vduowan_list = $('#vduowan');
        vduowan_list.html('');
        $('.news-cont').eq(index).removeClass('ui-hide').siblings().addClass('ui-hide');
        $('.main-sub-nav-btn').eq(0).addClass('current').siblings().removeClass('current');
        $('.main-cont').eq(0).removeClass('ui-hide').siblings().addClass('ui-hide');

        //专区筛选
        if(zq_href){
            $('.zq-btn').prop({'href':zq_href,'target':'_blank'}).show()
        }else{
            $('.zq-btn').hide();
        }

        //神镜头筛选
        if(sjt_id!=null){
            $('.vduowan-btn').show();
        }else{
            $('.vduowan-btn').hide();
        }

        if(bbs_id){
            $('.bbs-btn').show();
        }else{
            $('.bbs-btn').hide()
        }

        //虎牙直播筛选
        if(huya_id!=0){
            $('.main-huya-live').hide();
            $('.main-huya-'+huya_id).show();
            $('#main-huya-list-wrap').find('.add-list-more').hide();



        }else{
            $('.main-huya-live').hide();
            $('.main-huya-live:lt(48)').show();
            $('#main-huya-list-wrap').find('.add-list-more').show();
        }

        _this.parent().addClass('current').siblings().removeClass('current');
    })

    seajs.use('mediaelementplayer', function(){

        //视频初始化
        var MediaElementPlayer = null, dataSource = null, mediaElementMap = [];
        var PlayerStatus = {
            donelist: [],
            playing: 0,
            lastplay: 0
        };
        function _getMediaElementPlayer(position, view) {
            if ("undefined" !== typeof mediaElementMap[position]) {
                return mediaElementMap[position];
            }
            if (null != view && view.find("video").attr("src")) {
                mediaElementMap[position] = new MediaElementPlayer("#video_" + position, {
                    loop: true,
                    hideVideoControlsOnLoad: true,
                    features: [ "playpause", "progress", "current", "duration", "tracks", "volume", "fullscreen" ],
                    customError: ""
                });
                // Get Time
                $("#video_" + position).on("pause ended", {
                    position: position,
                    view: view
                }, function(e) {
                    var m = mediaElementMap[position];
                    if ("ended" == e.type) {
                        m._startTime = 0;
                    } else {
                        m._startTime = m.getCurrentTime();
                    }
                    var vid = $("#position_" + position).attr("data-vid");

                    if (position == PlayerStatus.lastplay || e.type == "ended") {
                        if (typeof PlayerStatus.donelist[vid] == "undefined") {
                            PlayerStatus.donelist[vid] = 1;
                            var totalTime = this.duration;
                            if (e.type == "ended") {
                                var statTime = totalTime;
                            } else {
                                var statTime = m._startTime;
                            }
                        }
                    }
                });
                $("#video_" + position).on("play", {
                    position: position,
                    view: view
                }, function(e) {
                    var m = mediaElementMap[position];
                    if (m._startTime && m._startTime > 0) {
                        m.setCurrentTime(m._startTime);
                    }
                    PlayerStatus.lastplay = PlayerStatus.playing;
                    PlayerStatus.playing = position;
                });
                $("#video_" + position).on("contextmenu", function(e) {
                    return true;
                });
                return mediaElementMap[position];
            } else {
                return null == view ? null : view.find("video")[0];
            }
        }

        function Player(position, view) {
            this.position = position;
            this.view = view;
            this.videoObj = null == view ? null : view.find("video");
        }
        Player.init = function(_MediaElementPlayer, _dataSource) {
            MediaElementPlayer = _MediaElementPlayer;
            dataSource = _dataSource;
        };
        Player.prototype = {
            play: function() {
                if (!this.videoObj) return;
                if ("meta" != this.videoObj.attr("preload")) {
                    this.videoObj.attr("preload", "meta");
                }
                if (!this.videoObj.attr("src")) {
                    this.videoObj.attr("src", this.videoObj.data("src"));
                }
                var video = _getMediaElementPlayer(this.position, this.view);
                if (video && video.play && video.media && video.media.load) {
                    video.play();
                }
            },
            pause: function() {
                if (!this.videoObj) return;
                if ("meta" != this.videoObj.attr("preload")) {
                    this.videoObj.attr("preload", "meta");
                }
                if (!this.videoObj.attr("src")) {
                    this.videoObj.attr("src", this.videoObj.data("src"));
                }
                var video = _getMediaElementPlayer(this.position, this.view);
                if (video && video.pause) {
                    video.pause();
                }
            },
            remove: function() {
                if (!this.videoObj) return;
                if ("none" != this.videoObj.attr("preload")) {
                    this.videoObj.attr("preload", "none");
                }
                if (this.videoObj.attr("src")) {
                    this.videoObj.removeAttr("src");
                }
            }
        };


        $('.main-sub-nav').find('li.main-sub-nav-btn').on('click',function(){
            var index = $(this).index();
            $('.main-sub-nav').find('li').removeClass('current');
            $(this).addClass('current');
            $('.main-cont-wrap').find('.main-cont').addClass('ui-hide');
            $('.main-cont-wrap').find('.main-cont').eq(index).removeClass('ui-hide');

            if($(this).find('a').text()=='直播' && $('[data-entry="main-huya-live"]').find('.main-huya-live').length==0){
                //虎牙直播内容 [data-entry="main-huya-live"]  樊晨
                $('[data-entry="main-huya-live"]').on('data:entry', function(e, result){
                    var huya_list = $(this);
                    var huya_list_data = result.data.data, i,tempArr=[],page=49;
                    //初始化
                    for(i in huya_list_data){
                        tempArr.push('<div class="main-huya-live main-huya-'+huya_list_data[i].gameid+'"><a href="'+huya_list_data[i].liveurl+'" target="_blank">' +
                            '<img src="http://assets.dwstatic.com/common/img/blank.png" data-original="'+huya_list_data[i].videocaptureurl+'" alt="'+huya_list_data[i].livetitle+'" class="main-huya-poster">' +
                            '<span class="ui-figure__hover"><i></i></span><div class="main-huya-intro u-clearfix">' +
                            '<p class="main-huya-title">'+huya_list_data[i].livetitle+'</p>' +
                            '<div class="main-huya-author"><img src="'+huya_list_data[i].avatarurl+'" alt="'+huya_list_data[i].nick+'"><span>'+huya_list_data[i].nick+'</span></div>' +
                            '<div class="main-huya-meta"><i></i>'+huya_list_data[i].attendeecount+'人在线</div></div></a></div>')
                    }

                    huya_list.append(tempArr.join(''));
                    huya_list.find('.main-huya-live:lt(48)').show();
                    $('.js-lazy img').lazyload({
                        failurelimit : 5,
                        skip_invisible : false
                    })
                    huya_list.removeClass('ui-loading');
                    huya_list.parent().find('.add-list-more')
                        .removeClass('ui-hide')
                        .on('click',function(){
                            var _thisbtn = $(this);
                            if(page<=huya_list_data.length){
                                $('.main-huya-live').slice(page,page+48).show();
                                page += 48;
                            }else{
                                _thisbtn.html('已加载完毕');
                            }
                        })


                }).on('data:fail', {
                        classname : 'ext-center'
                    }, onDataFailHandler)
                    .on('data:refresh', onDataRefreshHandler)
                    .getData('http://api.huya.com/way/waylives?wayid=83&sign=2863a90729a0b70735ce7666cc2059d7',false,'jsonp');
            }

            if($(this).find('a').text()=='视频'){
                //神镜头 陈宇杰
                var vduowan_list = $('#vduowan');
                vduowan_list.html('');
                vduowan_list.addClass('ui-loading');
                //请求数据
                $.ajax({
                    url: 'http://v.duowan.com/index.php?r=video/list&channel='+($('.main-nav').find('.current').find('a').attr('sjt-id') || "")+'&hidevid=&hot_vid=3280332&page=1&pageSize=12&sort_key=zan&sort=desc',
                    type: 'get',
                    timeout: 2000,
                    dataType: 'jsonp'
                }).done(function(result){

                    var vduowan_list_data = result.data, i,tempArr=[],tagsStr;
                    for(i in vduowan_list_data){
                        tagsStr = '';
                        tagsStr+=vduowan_list_data[i].video_tags !=""?vPlayTag(vduowan_list_data[i].video_tags):'';
                        tempArr.push(' <div class="video-list" id="position_'+i+'" data-position="'+i+'"><div class="video-top-bar">' +
                            '<img src="'+vduowan_list_data[i].user_avatar+'" alt="" class="fltL">' +
                            '<p class="fltL">'+vduowan_list_data[i].user_nickname+'<em class="video-ptime">上传于'+vduowan_list_data[i].video_upload_time.split(' ')[0]+'</em></p><span class="tag fltR">#'+vduowan_list_data[i].video_channel_label+'</span></div><div class="video-wrap">' +
                            '<video class="video-duopai" controls  preload="auto" width="100%" height="100%" poster="'+vduowan_list_data[i].video_cover+'" data-src="'+vduowan_list_data[i].video_url+'" id="video_'+i+'">' +
                            '<object width="100%" height="100%" type="application/x-shockwave-flash" data="js/flashmediaelement.swf">' +
                            '<param name="movie" value="js/flashmediaelement.swf" />' +
                            '<param name="flashvars" value="controls=true&amp;file=http://w5.dwstatic.com/54/3/1615/1707199-100-1460596995.mp4" />' +
                            '<img src="'+vduowan_list_data[i].video_cover+'" width="100%" height="100%" alt="No video playback capabilities" /></object></video></div><div class="video-info-bar">' +
                            '<h2 class="video-title fltL">'+vduowan_list_data[i].video_title+'</h2>' +
                            ''+tagsStr+'</div><div class="video-info"><a class="video-zan video-info-btn" data-vid="'+vduowan_list_data[i].vid+'"><i></i>'+vduowan_list_data[i].video_zan_num+'赞</a><a class="video-cai video-info-btn" data-vid="'+vduowan_list_data[i].vid+'"><i></i>'+vduowan_list_data[i].video_cai_num+'踩</a><div class="video-share video-info-btn" id="video-share"><i></i>分享<div class="ic-share clearfix"><div class="bdsharebuttonbox"  data-tag="share_1"><span>分享到</span><a class="ic-share-wx" data-cmd="weixin" title="分享到微信">微信</a><a class="ic-share-qq" data-cmd="sqq" title="分享到qq">QQ</a><a class="ic-share-wb" data-cmd="tsina" title="分享到微博">微博</a></div><div class="share-clipbord"><div class="copy-item clearfix"><span class="copy-item-title">视频地址</span><input type="text" disabled="disabled" value="123123123"><a class="btn-copy" href="javascript:;">复制</a></div><div class="copy-item clearfix"><span class="copy-item-title">html代码</span><input type="text" disabled="disabled" value="456456456"><a class="btn-copy" href="javascript:;">复制</a></div><div class="copy-item clearfix"><span class="copy-item-title">FLASH</span><input type="text" disabled="disabled" value="789789789"><a class="btn-copy" href="javascript:;">复制</a></div></div></div></div><div class="video-comment video-info-btn" id="comment-show"><a href="http://v.duowan.com/play/'+vduowan_list_data[i].vid+'" target="_blank"><i></i>'+vduowan_list_data[i].video_raw_comment_num+'</a></div></div></div>');
                    }
                    vduowan_list.html('').append(tempArr.join(''));


                    //$('.video-list').each(function(){
                    //    var position = $(this).attr('data-position');
                    //    new MediaElementPlayer('#video_'+position,{
                    //        loop: true,
                    //        hideVideoControlsOnLoad: true,
                    //        features: ['playpause','progress','current','duration','tracks','volume','fullscreen'],
                    //        customError: ""
                    //    });
                    //})
                    vduowan_list.removeClass('ui-loading')
                }).error(onDataFailHandler)


                /**
                 * 返回标签
                 * @param str
                 * @returns {string}
                 */
                function vPlayTag(str){
                    var tagArr = str.split(','),
                        tagsStr='';
                    for(var j=0;j<(tagArr.length>5?5:tagArr.length-1);j++){
                        tagsStr+='<span class="tag fltR">#'+tagArr[j]+'</span>'
                    }
                    return tagsStr
                }
            }

            if($(this).find('a').text() == '论坛'){
                if($('.main-nav').find('.current').find('a').attr('sjt-id')!='tieba'){
                    //论坛接口 李响
                    $('[data-entry="main-bbs-live"]').one('data:entry', function(e, result){
                        var bbs_list = $(this);
                        var bbs_list_data = result.data.Variables.forum_threadlist, i, j,tempArr=[],imgwrap="",summary="";
                        for(i in bbs_list_data){
                            imgwrap="";
                            summary="";
                            if(bbs_list_data[i].imagelist){
                                imgwrap+='<div class="bbs-col-img-wrap u-clearfix">';
                                for(j in bbs_list_data[i].imagelist){
                                    imgwrap+='<div class="bbs-col-img-list"><img src="'+bbs_list_data[i].imagelist[j]+'" alt="'+bbs_list_data[i].subject+'"></div>'
                                }
                                imgwrap+="</div>"
                            }
                            if(bbs_list_data[i].summary)summary+='<span class="bbs-col-intro">'+bbs_list_data[i].summary+'</span>';
                            tempArr.push('<div class="bbs-col"><a href="http://bbs.duowan.com/thread-'+bbs_list_data[i].tid+'-1-1.html" class="bbs-col-link"><div class="bbs-col-reply">'+bbs_list_data[i].replies+'</div>' +
                                '<div class="bbs-col-cont"><p class="bbs-col-title">'+bbs_list_data[i].subject+'</p>'+summary+'<div class="bbs-col-user"><i></i>'+bbs_list_data[i].author+'</div>'+imgwrap+'</div></div></a> </div>');
                        }
                        bbs_list.html('').append(tempArr.join(''))
                    }).on('data:fail', {
                            classname : 'ext-center'
                        }, onDataFailHandler)
                        .on('data:refresh', onDataRefreshHandler)
                        .getData('http://bbs.duowan.com/api/mobile/?module=forumdisplay&fid='+bbs_id+'&version=2');

                }else{
                    //我的世界贴吧
                    $('[data-entry="main-bbs-live"]').one('data:entry', function(e, result){
                        var bbs_list = $(this);
                        var bbs_list_data = result.data.data.threads, i, j,tempArr=[],imgwrap="",summary="";
                        for(i in bbs_list_data){
                            imgwrap="";
                            summary="";
                            if(bbs_list_data[i].img_list && bbs_list_data[i].img_list.length>0){
                                imgwrap+='<div class="bbs-col-img-wrap u-clearfix">';
                                for(j =0;j<(bbs_list_data[i].img_list.length>3?3:bbs_list_data[i].img_list.length);j++){
                                    imgwrap+='<div class="bbs-col-img-list"><img src="'+bbs_list_data[i].img_list[j]+'" alt="'+bbs_list_data[i].title+'"></div>'
                                }
                                imgwrap+="</div>"
                            }
                            if(bbs_list_data[i].desc)summary+='<span class="bbs-col-intro">'+bbs_list_data[i].desc+'</span>';
                            tempArr.push('<div class="bbs-col"><a href="'+bbs_list_data[i].post_url+'" class="bbs-col-link"><div class="bbs-col-reply">'+bbs_list_data[i].replies+'</div>' +
                                '<div class="bbs-col-cont"><p class="bbs-col-title">'+bbs_list_data[i].title+'</p>'+summary+'<div class="bbs-col-user"><i></i>'+bbs_list_data[i].author+'</div>'+imgwrap+'</div></div></a> </div>');
                        }
                        bbs_list.html('').append(tempArr.join(''))
                    }).on('data:fail', {
                            classname : 'ext-center'
                        }, onDataFailHandler)
                        .on('data:refresh', onDataRefreshHandler)
                        .getData('http://tieba.duowan.com/?r=post/list&page=1pageSize=40');
                }

            }
        })
    })


    // 首屏虎牙直播精彩世界 数据入口 [data-entry="primary-live-wonderful"] 覃永婷/黄湘
    $('[data-entry="primary-live-wonderful"]').on('data:entry', function(e, result){
        var primary_live_wonderful = $(this);
        var primary_live_wonderful_data = result.data.data['b_0'][2][0].livedatas;
        primary_live_wonderful.find('.ui-list__item').each(function(index){
            var item = $(this);
            var item_data = primary_live_wonderful_data[index+2];
            var item_list = item.lego().list({
                link : item_data.nick,
                href : huya_hosts+item_data.privateHost+huya_origin,
                tit : item_data.nick
            });
            item_list.game.contents()[1].data = item_data.gameFullName;
            item_list.meta.contents()[1].data = (item_data.totalCount||0);
        });
    }).on('data:fail', function(){
        var self = this;
        define('local[primay-live-wonderful]', function(){
            $(self).css('visibility','hidden');
        });
        if (seajs.cache[seajs.resolve('local[primay-live]')]) {
            seajs.use(['local[primay-live]', 'local[primay-live-wonderful]']);
        }
    }).on('data:refresh', function(){
        $(this).css('visibility','');
        return false
    }).getData(huya_domain, true);



    // 手游礼包 数据入口 [data-entry="5253-gift"] 张洁/曲琨
    $('[data-entry="5253-gift"]').on('data:entry', function(e, result){
        var mobi_gift = $(this);
        var mobi_gift_data = result.data;
        mobi_gift.find('.ui-list__item').each(function(index){
            var item = $(this);
            var item_data = mobi_gift_data[index];
            var item_list = item.lego().list({
                game : item_data.name,
                number : '剩余'+(item_data.giftsLast||0),
                // +'/'+(item_data.giftsTotal||0),
                href : item_data.url
            });
            item_list.game.find('a').attr({
                title : item_data.name
            });
        });
        mobi_gift.removeClass('ui-loading');
    }).on('data:fail', {
            classname : 'ext-center ext-patternless'
        }, onDataFailHandler)
        .on('data:refresh', onDataRefreshHandler)
        .getData('http://api.5253.com/api/duowanIndexGifts.json',true);



    $(window).one('scroll:privilege',function () {

        // 特权发号 数据入口 [data-entry="primary-privilege"] 曾雅文/陈祁
        (function(){
            var getNumber = function(e, result){
                var item = $(this);
                var item_data = result.data;
                item.removeClass('is-loading').html((item_data.number||0) + '已领');
            }
            $('[data-entry="primary-privilege"]').find('.ui-list__number').each(function(){
                var id = $(this).html();
                // var url = 'http://ka.duowan.com/v5/game/getBookCount?id='+id;
                // var url = 'http://ka.duowan.com/tqappApi/getGameBookcount?id='+id;
                var url = 'http://ka.duowan.com/tqappApi/getActGotNumber?actInfo='+id;
                $(this).on('data:entry', getNumber).getData(url,true);
            });
        })();

    }).one('scroll:mission',function () {

        // 顶栏 多玩豆商城 每日任务 数据入口 [data-entry="topbar-mission"] 张莉莉/陈宇杰
        // 多玩豆商城任务 数据入口 [data-entry="primary-mall-mission"] 张莉莉/陈宇杰
        // var primary_mall_domain = 'http://dwd.webdev.duowan.com/index.php';
        var primary_mall_domain = 'http://dou.duowan.com/index.php';
        $(document).one('udb:login', function(){
            $('[data-entry="topbar-mission"]').one('data:entry', function(e, result){
                var topbar_mission = $(this);
                var topbar_mission_data = result.data;
                var mission_finished = topbar_mission_data.tasklog_count - 0;
                var mission_total = topbar_mission_data.mission_count - 0;
                var mission_unfinish = mission_total - mission_finished;
                // 顶栏提示今日任务剩余数量
                topbar_mission.find('.ui-topbar__mission i').html(mission_unfinish).animate({
                    opacity : 1
                });
            }).on('data:refresh', function(e, result){
                var topbar_mission = $(this);
                var topbar_mission_data = result.data;
                var mission_finished = topbar_mission_data.tasklog_count - 0;
                var mission_total = topbar_mission_data.mission_count - 0;
                var mission_unfinish = mission_total - mission_finished;
                // 顶栏更新今日任务剩余数量
                topbar_mission.find('.ui-topbar__mission i').html(mission_unfinish);
            }).getData(primary_mall_domain + '?r=home/Getmission&type=jsonp',true);

            $('[data-entry="primary-mall-mission"]').one('data:entry', function(e, result){
                var primary_mall_mission = $(this);
                var primary_mall_mission_data = result.data;
                var mission_finished = primary_mall_mission_data.tasklog_count - 0;
                var mission_total = primary_mall_mission_data.mission_count - 0;
                var mission_unfinish = mission_total - mission_finished;
                // 多玩豆商城任务模块提示任务进度
                primary_mall_mission.find('.ui-mission__login').hide();
                var mission_txt = primary_mall_mission.find('.ui-mission__txt').show();
                mission_txt.find('em:eq(0)').html(mission_finished);
                mission_txt.find('em:eq(1)').html(mission_total);
                var mission_progress = primary_mall_mission.find('.ui-mission__progress').show().find('ul');
                var mission_li = $('<li>');
                var gap = 2;
                var width = Math.floor(mission_progress.width()/mission_total-gap);
                var fadeIn = function(one, i){
                    setTimeout(function(){
                        one.fadeIn();
                    },300*(i+1));
                }
                for ( var i = 0; i < mission_total; i++) {
                    var one = mission_li.clone().css({
                        width : width
                    });
                    if (i < mission_finished) {
                        one.addClass('is-active');
                    }
                    mission_progress.append(one);
                    fadeIn(one,i);
                }
            }).on('data:refresh', function(e, result){
                var primary_mall_mission = $(this);
                var primary_mall_mission_data = result.data;
                var mission_finished = primary_mall_mission_data.tasklog_count - 0;
                // 多玩豆商城任务模块更新任务进度
                primary_mall_mission.find('.ui-mission__txt em:eq(0)').html(mission_finished);
                primary_mall_mission.find('.ui-mission__progress li:lt(' + mission_finished + ')').css({
                    transition : 'all 400ms'
                }).addClass('is-active');
            }).getData(primary_mall_domain + '?r=home/Getmission&type=jsonp',true);
        }).trigger('udb');
        // 多玩豆商城抢购 数据入口 [data-entry="primary-mall"] 张莉莉/陈宇杰
        seajs.use(['moment', 'popbox'], function(){
            var body = $('body');
            // 倒计时
            (function(){
                var moment = window.moment;
                var units = ['second','minute','hour'];
                var scales = [60,60,99];
                var format = function(val){
                    return val > 0 ? (val < 10 ? ('0' + val) : val > 99 ? 99 : val) : '00'
                }
                $.fn.extend({
                    countdown : function(callback){
                        return this.each(function(){
                            var now = $.now();
                            var time = $(this).data('time');
                            var wait_time = moment(time).diff(now,'s');
                            if (wait_time > 0) {
                                var result = [];
                                $(units).each(function(index, unit){
                                    var scale = scales[index];
                                    var next = format(wait_time%scale);
                                    result.unshift(next);
                                    wait_time = parseInt(wait_time/scale);
                                });
                                $(this).html(result.join(':'));
                                setTimeout($.proxy($.fn.countdown, $(this), callback), 1000);
                            } else {
                                callback.call($(this));
                            }
                        })
                    }
                });
            })();
            // 商品展示接口
            $('[data-entry="primary-mall"]').on('data:entry', function(e, result){
                var primary_mall = $(this);
                var primary_mall_data = result.data;
                primary_mall.find('.ui-figure__item').each(function(index){
                    var item = $(this);
                    var item_data = primary_mall_data[index];
                    var caption;
                    var countdown = false;
                    var selling = false;
                    var classname = '';
                    if (item_data.goods_num) {
                        var start_time = Date.parse(item_data.start_time.replace(/-/g,'/'));
                        var end_time = Date.parse(item_data.end_time.replace(/-/g,'/'));
                        var now = $.now();
                        if (now < start_time && start_time < end_time) {
                            caption = '还剩<span class="ui-figure__time">$time</span>开始';
                            classname = 'is-waiting';
                            countdown = true;
                        } else if (now >= start_time && now <= end_time) {
                            caption = '立即兑换';
                            classname = 'is-active';
                            selling = true;
                        } else {
                            caption = '已结束';
                            classname = 'is-end';
                        }
                    } else {
                        caption = '抢光了';
                        classname = 'is-end';
                    }
                    var item_figure = item.lego().figure({
                        caption : caption,
                        img : item_data.goods_pic,
                        alt : item_data.goods_name,
                        mask : item_data.goods_name
                    });
                    item.addClass(classname).on('selling:start', function(){
                        item_figure.href.data('selling','start');
                        item.trigger('selling:end');
                    }).on('selling:end', function(){
                        setTimeout(function(){
                            item.removeClass('is-active').addClass('is-end');
                            item_figure.caption.html('已结束');
                            item_figure.href.data('selling','end');
                        }, end_time - $.now());
                    });
                    item_figure.href.data('id', item_data.goods_id);
                    // 倒数并且开始selling
                    if (countdown) {
                        item_figure.find('.ui-figure__time').attr('data-time',start_time).countdown(function(){
                            item.removeClass('is-waiting').addClass('is-active');
                            item.find('.ui-figure__caption').html('立即兑换');
                            item.trigger('selling:start');
                        });
                    }
                    // 正在selling
                    if (selling) {
                        item.trigger('selling:start');
                    }
                });
                primary_mall.find('.ui-loading').removeClass('ui-loading');
            }).on('data:fail', {
                    classname : 'ext-center ext-patternless'
                }, onDataFailHandler)
                .on('data:refresh', onDataRefreshHandler)
                .on('click', 'a', function(){
                    if ($(this).data('selling') == 'start') {
                        var id = $(this).data('id');
                        if (dwUDBProxy) {
                            if (dwUDBProxy.isLogin()) {
                                // selling
                                var pop = $(document).data('mall-pop');
                                if (!pop) {
                                    var title = '确认兑换此商品？';
                                    var subtitle = '';
                                    var confirmText = '确认兑换';
                                    var confirmText2 = '取消';
                                    var pop = new DWPodPopbox({
                                        title : title,
                                        subtitle : subtitle,
                                        confirmText : confirmText,
                                        confirmCallback : function(){
                                            $(document).data('mall-pop-cb')();
                                        },
                                        confirmText2 : confirmText2
                                    });
                                    var element = pop.__el;
                                    element.addClass('ui-popbox');
                                    $(document).data('mall-pop', pop);
                                }
                                $(document).data('mall-pop-cb', $.proxy(function(){
                                    body.addClass('u-wait');
                                    $(this).addClass('is-exchanging').getData(primary_mall_domain + '?r=order/placeorder&type=jsonp&goods_id=' + id, true);
                                }, this));
                                pop.show(6,0,$(window).height()/2-pop.__el.height()/2);
                            } else {
                                dwUDBProxy.login('');
                            }
                        }
                    }
                }).on('data:entry', 'a', function(e, result){
                body.removeClass('u-wait');
                $(this).removeClass('is-exchanging');
                var data = result.data;
                var title = data.code > 0 ? '兑换成功！' : '兑换失败！';
                var subtitle = data.msg;
                var confirmText = ($('.ui-topbar span.ui-topbar__mission i').html()-0 == 0) ? '今日任务已完成' : '继续做任务';
                var pop = new DWPodPopbox({
                    title : title,
                    subtitle : subtitle,
                    confirmText : confirmText
                });
                pop.show(6,0,$(window).height()/2-pop.__el.height()/2);
                return false
            }).on('data:fail', 'a', function(){
                return false
            }).getData(primary_mall_domain + '?r=goods/Showgoods&type=jsonp', true);
        });

    }).one('scroll:rank',function () {

        // 期待榜 数据入口 [data-entry="rank-anticipated"] 简敏辉/吴杰华
        $('[data-entry="rank-anticipated"]').on('data:entry', function(e, result){
            var rank_anticipated = $(this);
            var rank_anticipated_data = result.data.list;
            rank_anticipated.find('.ui-list__item').each(function(index){
                var item = $(this);
                var item_data = rank_anticipated_data[index];
                var item_list = item.lego().list({
                    rank : (item_data.recom_num||0),
                    href : item_data.url
                });
                item_list.name.find('a').html(item_data.game_name);
                if (item_data.change) {
                    item.addClass(item_data.change > 0 ? 'has-rise' : 'has-fall');
                }
                item.find('.ui-list__img').attr({
                    'src' : item_data.list_pic,
                    'alt' : item_data.game_name
                });
                item_list.link.attr('href', item_data.cn);
            });
            rank_anticipated.find('.sp-rank-anticipated').removeClass('ui-loading');
        }).on('data:fail', {
                classname : 'ext-center'
            }, onDataFailHandler)
            .on('data:refresh', onDataRefreshHandler)
            .getData('http://ku.newgame.duowan.com/index.php?type=jsonp&r=api/Getforwardlist');

        // 新游榜 数据入口 [data-entry="rank-new"] 简敏辉/吴杰华
        $('[data-entry="rank-new"]').on('data:entry', function(e, result){
            var rank_new = $(this);
            var rank_new_data = result.data.rankList;
            rank_new.find('.ui-list__item').each(function(index){
                var item = $(this);
                var item_data = rank_new_data[index];
                var item_list = item.lego().list({
                    rank : (item_data.hot_num||0),
                    href : item_data.url
                });
                item_list.name.find('a').html(item_data.game_name);
                var change = index + 1 - item_data.last_rank;
                if (change) {
                    item.addClass(change < 0 ? 'has-rise' : 'has-fall');
                }
                item.find('.ui-list__img').attr({
                    'src' : item_data.list_pic,
                    'alt' : item_data.game_name
                });
                item_list.link.attr('href', item_data.portal_url.cn);
            });
            rank_new.find('.sp-rank-new').removeClass('ui-loading');
        }).on('data:fail', {
                classname : 'ext-center'
            }, onDataFailHandler)
            .on('data:refresh', onDataRefreshHandler)
            .getData('http://ku.newgame.duowan.com/index.php?type=jsonp&r=api/Getranklist');

// 热游榜 数据入口 [data-entry="rank-hot"] 简敏辉/吴杰华
        $('[data-entry="rank-hot"]').on('data:entry', function(e, result){
            var rank_hot = $(this);
            var rank_hot_data = result.data.rankList;
            rank_hot.find('.ui-list__item').each(function(index){
                var item = $(this);
                var item_data = rank_hot_data[index];
                var item_list = item.lego().list({
                    rank : item_data.hot_num,
                    href : item_data.url
                });
                item_list.name.find('a').html(item_data.game_name);
                var change = item_data.last_rank - item_data.rank;
                if (change) {
                    item.addClass(change > 0 ? 'has-rise' : 'has-fall');
                }
                item.find('.ui-list__img').attr({
                    'src' : item_data.list_pic,
                    'alt' : item_data.game_name
                });
                item_list.link.attr('href', item_data.portal_url.cn);
            });
            rank_hot.find('.sp-rank-hot').removeClass('ui-loading');
        }).on('data:fail', {
                classname : 'ext-center'
            }, onDataFailHandler)
            .on('data:refresh', onDataRefreshHandler)
            .getData('http://ku.newgame.duowan.com/index.php?type=jsonp&r=api/Getranklist&listName=hotgametop');

    }).one('scroll:gtable',function () {

        // 新游测试表 数据入口 [data-entry="rank-test"] 简敏辉/吴杰华
        $('[data-entry="rank-test"]').on('data:entry', function(e, result){
            var rank_test = $(this);
            var rank_test_data = result.data.list;
            rank_test.find('.ui-list__item').each(function(index){
                var item = $(this);
                var item_data = rank_test_data[index];
                var item_list = item.lego().list({
                    date : (function(){
                        var date = item_data.beta_time.split('-');
                        date.shift();
                        return date.join('-')
                    })(),
                    game : item_data.game_name,
                    status : item_data.beta_number,
                    href : item_data.url
                });
                if (item_data.beta_number == '首测') {
                    item_list.status.addClass('u-highlight');
                }
                if (item_data.dw_qz) {
                    item.find('.ui-list__preview a').attr({
                        href : item_data.dw_qz
                    });
                } else {
                    item.find('.ui-list__preview').html('---');
                }
                if (item_data.dw_sw) {
                    item.find('.ui-list__try a').attr({
                        href : item_data.dw_sw
                    });
                } else {
                    item.find('.ui-list__try').html('---');
                }
                if (item_data.takepartads) {
                    item.find('.ui-list__green').attr({
                        href : item_data.takepartads
                    });
                } else {
                    item.find('.ui-list__green').addClass('is-none').attr({
                        href : 'javascript:'
                    }).html('---');
                }
                item.game.find('a').attr({
                    title : item_data.game_name
                })
                item.find('.ui-list__orange').attr({
                    href : item_data.portal_url
                });
            });
            rank_test.removeClass('ui-loading');
        }).on('data:fail', {
                classname : 'ext-center'
            }, onDataFailHandler)
            .on('data:refresh', onDataRefreshHandler)
            .getData('http://ku.newgame.duowan.com/index.php?type=jsonp&r=api/Getnewgamebeta&pageSize=18&pageNum=1&is_push=1');

    }).on('scroll:lazy', function(e, lazy){
        var index = lazy.now;
        if (lazy.id.length == lazy.done.length) {
            $(window).off('scroll:lazy');
        } else {
            for (var i = index; i >= 0; i--) {
                var id = lazy.id[i];
                if ($.inArray(id, lazy.done) == -1) {
                    lazy.done.push(id);
                    // console.log(id); //%% 提示模块id 每个模块只触发一次
                    $(window).trigger('scroll:'+id);
                }
            }
        }
    });

    // 悬浮导航
    (function(){
        var body = $('body');
        var body_html = $('body,html');
        var sidebar = $('.g-col-335');
        var sidebar2 = $('.ui-sidebar');
        var backtotop = sidebar2.find('.ui-backtotop');
        var isBtnShow = false;
        var isBarHide = true;
        var isShort = $(window).height() < 585 ? !!sidebar2.addClass('is-pin') : false;
        var gap = 50;
        var hash = $(); // $#id 记录模块jq对象的数组
        var lazy = { // 记录模块id值的数组
            id : [],
            done : []
        };
        var items = sidebar.find('.side-col');
        items.each(function(){
            var id = $(this).prop('id');
            if (id.length>0) {
                hash = hash.add($('#'+id));
                lazy.id.push(id);
            }
        });
        var length = hash.length;
        var prev = $();
        $(window).on('scroll', function(){
            var now = $(window).scrollTop();
            var height = $(document).height()/5;
            // 显示/隐藏`回到顶部`按钮
            if (now > height && !isBtnShow) {
                backtotop.stop().fadeIn(300);
                isBtnShow = true;
            } else if (now <= height && isBtnShow){
                backtotop.stop().fadeOut(300);
                isBtnShow = false;
            }

            var i = 0;
            hash.each(function(){
                var breakpoint = $(this).offset().top;
                if (now <= breakpoint - 50) {
                    i--;
                    return false
                } else {
                    i++;
                }
            });
            i = i < 0 ? 0 : (i >= length ? length-1 : i);
            lazy.now = i;
            $(window).trigger('scroll:lazy', lazy);
        }).on('resize:narrow', function(){
            body.addClass('g-narrow');
        }).on('resize:wide', function(){
            body.removeClass('g-narrow');
        }).on('resize', function(){
            var now = $(window).width();
            // 越过临界点 隐藏导航
            if (now < 1160 && !isBarHide) { // 1000 + (12 + 56 + 12)*2
                sidebar2.stop().hide();
                isBarHide = true;
            } else if (now >= 1160 && isBarHide) {
                sidebar2.fadeIn();
                isBarHide = false;
            }
            // 越过临界点 导航以顶部为标准固定
            var height = $(window).height();
            if (height < 500 && !isShort) {
                sidebar2.addClass('is-pin');
                isShort = true;
            } else if (height >= 500 && isShort) {
                sidebar2.removeClass('is-pin');
                isShort = false;
            }
        });
        backtotop.on('click', function(){
            var now = $(window).scrollTop();
            body_html.stop().animate({
                scrollTop: 36
            }, 300 + (now - 36)/20, 'linear', function(){
                $(window).trigger('scroll');
            });
        });

        $('.ui-gwreg')
            .on('mouseover',function(){
                $(this).parent().find('.reg-box').show();
            })
            .on('mouseout',function(){
                $(this).parent().find('.reg-box').hide();
            })
    })();

    // 标题
    (function(){
        if (pageVisibility.visibilityState) {
            var visible_title = document.title;
            var hidden_title = $('title').attr('leave');
            hidden_title = hidden_title ? hidden_title : visible_title;
            pageVisibility.visibilitychange(function(){
                document.title = pageVisibility.hidden ? hidden_title : visible_title
            });
        }
    })();


    // `页面宽屏/窄屏` 切换时的事件监听
    // if (!window._compatible) {
    //     $(window).on('resize', function(){
    //         var now = $(window).width();
    //         // 页面大小改变时 越过临界点触发
    //         if (now < 1400 && !isNarrow) {
    //             // 变窄
    //             $(window).trigger('resize:narrow');
    //             isNarrow = true;
    //         } else if (now >= 1400 && isNarrow) {
    //             // 变宽
    //             $(window).trigger('resize:wide');
    //             isNarrow = false;
    //         }
    //     });
    // }

    $(window).trigger('resize').trigger('scroll');
    $(document).trigger('visibilitychange:once');

    // data-stat 统计
    (function(){
        var fixed = function(value){
            var ret = (value - 0 || 0) + 1;
            return ret < 10 ? (ret < 0 ? '00' : '0'+ret) : (ret+'')
        };
        var rule = {
            H1 : function(item){
                if (item.is('li a')) {
                    return this.Simple(item)
                        +this.Special(item)
                } else {
                    return ''
                }
            },
            H3 : function(item){
                if (item.is('.ui-tab__hd a')) {
                    return this.Special(item, '.ui-tab__hd')
                } else {
                    return this.Simple(item, 'ul')+this.Simple(item)
                }
            },
            B1L_02 : function(item){
                if (item.is('.ui-tab__hd a')) {
                    return this.Special(item, '.ui-tab__hd')
                } else {
                    return this.Special(item, '.ui-tab__panel')
                }
            },
            B1M_01 : function(item){
                if (item.is('.ui-tab__hd a')) {
                    return this.Special(item, '.ui-tab__hd')
                } else {
                    var children = item.closest('.ui-tab__panel').children();
                    var tmp = children.attr('data-stat-tmp');
                    if (!tmp) {
                        var index = 0;
                        children.each(function(){
                            if (!$(this).is('.ui-business')
                                &&!$(this).is('.s-space-video')
                                &&!$(this).is('.s-space-pic')
                                &&!$(this).is('.ui-primary__line')) {
                                if ($(this).is('.ui-caption')
                                    ||$(this).is('.ui-recommendation')
                                    ||$(this).is('.ui-figure.sp-primary-pic-main')
                                    ||$(this).is('.ui-list.sp-primary-pic-main')
                                    ||$(this).is('.ui-figure.sp-primary-video-main')) {
                                    index++;
                                }
                                $(this).attr('data-stat-tmp', fixed(index)+'_');
                            }
                        });
                    }
                    tmp = item.closest('[data-stat-tmp]').attr('data-stat-tmp');
                    if (item.is('.ui-caption a')) {
                        return tmp + 'tit_' + this.Special(item, '.ui-caption')
                    } else if (item.is('.ui-list.ext-today a')) {
                        if (item.is('.ui-list__tag a')) {
                            return tmp + this.Simple(item) + '_tag'
                        } else {
                            return tmp + this.Simple(item) + fixed($.inArray(item[0], item.parent().children('a')))
                        }
                    } else {
                        return tmp + this.Special(item, '[data-stat-tmp]')
                    }
                }
            },
            B1R_01 : function(item){
                if (item.is('.ui-caption a')) {
                    return 'tit_' + this.Special(item, '.ui-caption')
                } else if (item.is('.ui-figure.sp-primary-week a')) {
                    return this.Simple(item)
                } else {
                    return fixed(this.Simple(item))+this.Special(item)
                }
            },
            B1R_02 : function(item){
                return ''
            },
            B1R_03 : function(item){
                if (item.is('.ui-caption a')) {
                    return 'tit_' + this.Special(item, '.ui-caption')
                } else if (item.is('.ui-figure.sp-primary-privilege a')) {
                    return this.Simple(item)
                    // } else if (item.is('.ui-list.sp-primary-privilege a')) {
                } else {
                    return fixed(this.Simple(item)-0+1)+this.Special(item)
                }
            },
            B1R_04 : function(item){
                if (item.is('.ui-caption a')) {
                    return 'tit_' + this.Special(item, '.ui-caption')
                } else if (item.is('.ui-list.sp-primary-gift a')) {
                    return fixed((this.Simple(item)-1)*2+(this.Simple(item, '.ui-figure__item')-0+1))
                } else {
                    return this.Simple(item)
                }
            },
            B2L2_01 : function(item){
                return this.Special(item, '.ui-interview__body')
            },
            B3M_02 : function(item){
                return fixed(this.Simple(item, 'ul')-3)+this.Simple(item)
            },
            B3R_02 : function(item){
                if (item.is('.ui-caption a')) {
                    return 'tit_' + this.Special(item, '.ui-caption')
                } else {
                    return this.Simple(item)+this.Special(item)
                }
            },
            B4R_01 : function(item){
                return this.Simple(item)+this.Special(item)
            },
            B5R1_01 : function(item){
                if (item.is('.ui-caption a')) {
                    return 'tit_' + this.Special(item, '.ui-caption')
                } else {
                    return this.Simple(item)+this.Special(item)
                }
            },
            B6 : function(item){
                if (item.is('.ui-tab__hd a')) {
                    return this.Special(item, '.ui-tab__hd')
                } else {
                    return this.Simple(item)
                }
            },
            B7L : function(item){
                if (item.is('.ui-tab__hd a')) {
                    return this.Special(item, '.ui-tab__hd')
                } else if (item.is('.ui-rank__ext a')) {
                    return 'ext_' + this.Simple(item)
                } else if (item.is('.ui-tips__bd a')) {
                    return 'tips_' + this.Simple(item, '.ui-tips__panel')+this.Special(item,'.ui-tips__panel')
                } else {
                    return this.Simple(item)+this.Special(item)
                }
            },
            B7ML : function(item){
                if (item.is('.ui-caption a')) {
                    return 'tit_' + this.Special(item, '.ui-caption')
                } else if (item.is('.ui-tips__bd a')) {
                    return 'tips_' + this.Simple(item, '.ui-tips__panel')+this.Special(item,'.ui-tips__panel')
                } else {
                    return this.Simple(item)+this.Special(item)
                }
            },
            B7MR : function(item){
                return this['B7R'](item)
            },
            B7R : function(item){
                if (item.is('.ui-caption a')) {
                    return 'tit_' + this.Special(item, '.ui-caption')
                } else {
                    return this.Simple(item)+this.Special(item)
                }
            },
            F1 : function(item){
                return this.Simple(item.closest('.ui-sitemap__hd,.ui-sitemap__bd'))
                    +this.Special(item, '.ui-sitemap__item')
            },
            Default : function(item){
                if (item.is('.ui-caption a')) {
                    return 'tit_' + this.Special(item, '.ui-caption')
                } else if (item.is('.ui-topic a')) {
                    return fixed(item.index())
                } else if (item.is('.ui-media.ext-common a')) {
                    return this.Special(item, '.ui-media.ext-common')
                } else {
                    return this.Simple(item)
                }
            },
            Simple : function(item, selector){
                selector = selector || 'li';
                return fixed(item.closest(selector).index())
            },
            Special : function(item, selector, target){
                selector = selector || 'li';
                target = target || 'a';
                var all = item.closest(selector).find(target);
                return fixed($.inArray(item[0],all))
            },
            Tab : function(item){
                if (item.is('.ui-tab__hd a')) {
                    return 'T0_'
                } else if (item.is('.ui-tab__panel a')) {
                    return 'T'+(item.closest('.ui-tab__panel').index()+1)+'_'
                }
                return ''
            },
            getName : function(item, id){
                if (item.is('.ui-business a')) {
                    return ''
                } else {
                    var name = (this.Tab(item)+this[this[id]?id:'Default'](item))||'';
                    if (name) {
                        return [id,'_',name].join('')
                    } else {
                        return ''
                    }
                }
            }
        };
        $('[data-stat-block="B"]')
            .find('[data-stat-path="1"],[data-stat-path="2"],[data-stat-path="3"],[data-stat-path="4"],[data-stat-path="5"]')
            .find('[data-stat-path]')
            .each(function(){
                var children = $(this).children();
                if (children.length == 1 && children.is('.ui-box')) {
                    children = children.children();
                }
                var index = 0;
                children.each(function(){
                    var mod = $(this);
                    if (mod.is('.ui-caption') && mod.index() != 0) {
                        index++;
                        mod.attr('data-stat-path','_'+fixed(index));
                    } else if (mod.is('.ui-slide')
                        ||mod.is('.ui-media.ext-common')
                        ||mod.is('.ui-topic')
                        ||mod.is('.ui-list.sp-game-pc')
                        ||mod.is('.ui-figure.sp-primary-live')) {
                        mod.attr('data-stat-path','_'+fixed(index));
                        index++;
                    } else {
                        mod.attr('data-stat-path','_'+fixed(index));
                    }
                });
            });
        var onClickHandler = function(){
            var item = $(this);
            var id = item.attr('data-stat-area');
            var out = item.data('out');
            if (!id && out != true) {
                var block = item.closest('[data-stat-block]');
                var parents = item.parents();
                var value = block.attr('data-stat-block');
                var path = parents.filter('[data-stat-path]');
                var result = [];
                if (path.length) {
                    path.each(function(){
                        result.unshift($(this).attr('data-stat-path'));
                    });
                    result.unshift(value);
                    id = result.join('');
                    var name = rule.getName(item, id);
                    if (name) {
                        // 测试
                        // if (STAT[name]) {
                        //     STAT.LOG.push(name);
                        //     STAT[name] = STAT[name].add(item);
                        // } else {
                        //     STAT[name] = item;
                        // }
                        item.attr('data-stat-area', name);
                    } else {
                        item.data('out',true);
                    }
                } else {
                    item.data('out',true);
                }
            }
        };
        // 测试
        // window.STAT = {};
        // STAT.LOG = [];
        // window.RULE = rule;
        // $('[data-stat-block] [data-stat-path] a').each(onClickHandler);
        $('[data-stat-block]').on('click', '[data-stat-path] a', onClickHandler);
        // 测试
        // $(document.body).on("click", "a[data-stat-area]", function() {
        //     console.log($(this).attr('data-stat-area'));
        //     return false
        // });

    })();




});
/*
 keywords auto complete
 `syntax`
 return arguments typeof instanceof while switch case catch finally throw void break default debugger NaN Infinity parseInt parseFloat
 `javascript`
 window location replace hash search pathname port hostname origin href navigator platform userAgent clearTimeout clearInterval history back localStorage
 document domain documentElement head body title
 querySelector querySelectorAll getElementById getElementsByTagName getElementsByClassName
 appendChild insertBefore createElement removeChild
 attributes className style innerHTML innerText innerHeight innerWidth
 addEventListener removeEventListener click mouseover mousemove mouseout focus blur change input select submit reset input propertychange resize scroll touchstart touchmove touchend keydown keypress keyup transitionEnd stopPropagation preventDefault
 Object valueOf toString keys constructor
 Array indexOf push pop shift unshift slice splice split join sort reverse
 bind apply call __defineGetter__ __defineSetter__ __lookupGetter__ __lookupSetter__ __proto__
 Math random floor round ceil
 Date getTime getSeconds getMinutes getHours getSeconds getDate getDay getDay getMonth getFullYear
 JSON stringify parse
 RegExp global
 XMLHttpRequest send
 canvas getContext
 null
 undefined
 true false
 `jQuery`
 选择器 even odd gt lt root target contains empty hidden visible radio chechbox reset button file enabled disabled checked selected
 核心 length index data
 ajax get getJSON post serialize serializeArray beforeSend error success complete
 属性 attr removeAttr addClass removeClass toggleClass html text val
 css offset height width
 文档处理 append appendTo prepend prependTo after before insertAfter remove clone
 效果 show hide toggle fadeIn fadeOut
 工具 each extend parseJSON
 筛选 eq first last hasClass filter is map has not slice children closest find next offsetParent parent parents prev siblings add
 延迟对象 done fail promise always notify progress state
 `custom`
 is-active is-disabled
 `seajs`
 require exports module
 */